IX8<-function(data, variables,  Factor1, CF1=NULL, Factor2, CF2=1,
Factor3=NULL, CF3=NULL, Factor4=NULL, CF4=NULL,
combine=FALSE, trans=NULL, ResetPAR=TRUE,
mfrow=NULL, graph1="Boxplot", PAR1=NULL,  OrderCat1=NULL,
LabelCat1=NULL, COLOR1=NULL, BOXPLOT1=NULL, BEANPLOT1=NULL,
LEGEND1=NULL, AXIS1=NULL, MTEXT1= NULL, TEXT1=NULL,
graph2="Boxplot", PAR2=NULL, OrderCat2=NULL, LabelCat2=NULL,
COLOR2=NULL, BOXPLOT2=NULL, BEANPLOT2=NULL,
LEGEND2=NULL, AXIS2=NULL, MTEXT2= NULL, TEXT2=NULL,
graph3="Boxplot", PAR3=NULL, OrderCat3=NULL, LabelCat3=NULL,
COLOR3=NULL, BOXPLOT3=NULL, BEANPLOT3=NULL,
LEGEND3=NULL, AXIS3=NULL, MTEXT3= NULL, TEXT3=NULL,
graph4="Boxplot", PAR4=NULL, OrderCat4=NULL, LabelCat4=NULL,
COLOR4=NULL, BOXPLOT4=NULL, BEANPLOT4=NULL,
LEGEND4=NULL, AXIS4=NULL, MTEXT4= NULL, TEXT4=NULL,
file="Output.txt"){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=variables), subset(datos, select=Factor1))

if(!is.null(Factor2)){
datosT<-data.frame(datosT, subset(datos, select=Factor2))
}


if(!is.null(Factor3)){
datosT<-data.frame(datosT, subset(datos, select=Factor3))
}

if(!is.null(Factor4)){
datosT<-data.frame(datosT, subset(datos, select=Factor4))
}

if(!is.null(CF1)){
datosT<-data.frame(datosT, subset(datos, select=CF1))
}

if(!is.null(CF2)){
datosT<-data.frame(datosT, subset(datos, select=CF2))
}

if(!is.null(CF3)){
datosT<-data.frame(datosT, subset(datos, select=CF3))
}

if(!is.null(CF4)){
datosT<-data.frame(datosT, subset(datos, select=CF4))
}

datos<-na.exclude(datosT)

if (missing(LabelCat1)) LabelCat1=OrderCat1 else LabelCat1=LabelCat1
if (missing(LabelCat2)) LabelCat2=OrderCat2 else LabelCat2=LabelCat2
if (missing(LabelCat3)) LabelCat3=OrderCat3 else LabelCat3=LabelCat3
if (missing(LabelCat4)) LabelCat4=OrderCat4 else LabelCat4=LabelCat4


varSeleccion1<-NULL
varSeleccion2<-NULL

FF1<-Factor1
FF2<-Factor2
FF3<-Factor3
FF4<-Factor4

#Seleccion de un tipo de transformacion para las variables de inters. Si no se transforma la variable debe mantenerse la opcion "NULL".

if(!is.null(trans)){
 if(trans=="1/x2") varInteres1X2<-c(1,1) else varInteres1X2<-NULL
 if(trans=="1/x") varInteres1X<-c(1,1) else varInteres1X<-NULL
 if(trans=="LN") varInteresLN<-c(1,1) else varInteresLN<-NULL
 if(trans=="LOG") varInteresLOG10<-c(1,1) else varInteresLOG10<-NULL
 if(trans=="SQR") varInteresSQR<-c(1,1) else varInteresSQR<-NULL
 if(trans=="x2") varInteresX2<-c(1,1) else varInteresX2<-NULL
 if(trans=="x3") varInteresX3<-c(1,1) else varInteresX3<-NULL
 if(trans=="EXP") varInteresEX<-c(1,1) else varInteresEX<-NULL
 if(trans=="ASN") varInteresASN<-c(1,1) else varInteresASN<-NULL
}
else{
varInteres1X2<-NULL
varInteres1X<-NULL
varInteresLN<-NULL
varInteresLOG10<-NULL
varInteresSQR<-NULL
varInteresX2<-NULL
varInteresX3<-NULL
varInteresEX<-NULL
varInteresASN<-NULL
}

##Organizacion de los datos.
valores<-(datos[,variables])
if (length(varInteres1X2)==2) valores<-1/((datos[,variables])^2)
if (length(varInteres1X)==2) valores<-1/(datos[,variables])
if (length(varInteresLN)==2) valores<-log(datos[,variables])
if (length(varInteresLOG10)==2) valores<-log10(datos[,variables])
if (length(varInteresSQR)==2) valores<-sqrt((datos[,variables]))
if (length(varInteresX2)==2) valores<-(datos[,variables])^2
if (length(varInteresX3)==2) valores<-(datos[,variables])^3
if (length(varInteresEX)==2) valores<-exp(datos[,variables])
if (length(varInteresASN)==2) valores<-asin((datos[,variables]))




#Modelo lineal univariante y extraccion de residuos.
options(contrasts=c("contr.sum", "contr.poly"))



fo<-""
datos1<-data.frame(valores, datos[,Factor1],datos[,Factor2])
colnames(datos1)<-c(variables,Factor1,Factor2)

if(!is.null(CF1)){
leng<-length(CF1)
tem<-names(datos1)[2]
for(i in 1:leng){
tem<-paste(names(datos1)[CF1[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[2]
}

if(!is.null(CF2)){
leng<-length(CF2)
tem<-names(datos1)[3]
for(i in 1:leng){
tem<-paste(names(datos1)[CF2[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[3]
}

fo<-paste(names(datos1)[1],"~",fo)

if(!is.null(Factor3)){
fo<-""
datos1<-data.frame(valores,datos[,Factor1],datos[,Factor2],datos[,Factor3])
colnames(datos1)<-c(variables,Factor1,Factor2,Factor3)
if(!is.null(CF1)){
leng<-length(CF1)
tem<-names(datos1)[2]
for(i in 1:leng){
tem<-paste(names(datos1)[CF1[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[2]
}



if(!is.null(CF2)){
leng<-length(CF2)
tem<-names(datos1)[3]
for(i in 1:leng){
tem<-paste(names(datos1)[CF2[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[3]
}

if(!is.null(CF3)){
leng<-length(CF3)
tem<-names(datos1)[4]
for(i in 1:leng){
tem<-paste(names(datos1)[CF3[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[4]
}

fo<-paste(names(datos1)[1],"~",fo)

}

if(!is.null(Factor4)){
fo<-""
datos1<-data.frame(valores,datos[,Factor1],datos[,Factor2],datos[,Factor3],datos[,Factor4])
colnames(datos1)<-c(variables,Factor1,Factor2,Factor3, Factor4)

if(!is.null(CF1)){
leng<-length(CF1)
tem<-names(datos1)[2]
for(i in 1:leng){
tem<-paste(names(datos1)[CF1[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[2]
}



if(!is.null(CF2)){
leng<-length(CF2)
tem<-names(datos1)[3]
for(i in 1:leng){
tem<-paste(names(datos1)[CF2[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[3]
}

if(!is.null(CF3)){
leng<-length(CF3)
tem<-names(datos1)[4]
for(i in 1:leng){
tem<-paste(names(datos1)[CF3[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[4]
}


if(!is.null(CF4)){
leng<-length(CF4)
tem<-names(datos1)[5]
for(i in 1:leng){
tem<-paste(names(datos1)[CF4[i]+1],"/",tem)
}
fo<-paste(fo,"+",tem)
}else{
fo<-names(datos1)[5]
}

fo<-paste(names(datos1)[1],"~",fo)

}


modelo<-lm(fo,data=datos1)
resultado<-aov(modelo, data=datos1)
Resumenmodelo<-summary(resultado)


#Extraccion de residuos
residuos<-residuals(modelo)
datos3<-data.frame(residuos,datos1)

#Tamao de efecto.
Efectos<-summary.lm(modelo)

##Prueba de heterocedasticidad en los residuos.


if (ncol(datos1)==3) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3[, Factor1])
                        PruebaHetF2M<-lawstat::levene.test(datos3$residuos,datos3[,Factor2])
                        PruebaHetF3M<-NULL
                        PruebaHetF4M<-NULL
}
if (ncol(datos1)==4) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3[,Factor1])
                        PruebaHetF2M<-lawstat::levene.test(datos3$residuos,datos3[,Factor2])
                        PruebaHetF3M<-lawstat::levene.test(datos3$residuos,datos3[,Factor3])
                        PruebaHetF4M<-NULL
}
if (ncol(datos1)==5) {PruebaHetF1M<-lawstat::levene.test(datos3$residuos,datos3[,Factor1])
                        PruebaHetF2M<-lawstat::levene.test(datos3$residuos,datos3[,Factor2])
                        PruebaHetF3M<-lawstat::levene.test(datos3$residuos,datos3[,Factor3])
                        PruebaHetF4M<-lawstat::levene.test(datos3$residuos, datos3[,Factor4])
}

PruebaHet<-list("Factor1",PruebaHetF1M,"Factor2",PruebaHetF2M,"Factor3",PruebaHetF3M,"Factor4",PruebaHetF4M)


#prueba de normalidad en los residuos.
PruebaNormLillie<-nortest::lillie.test(residuos)
residshapiro<-length(residuos)
if(3 < residshapiro & residshapiro <5000){
PruebaNormShapiro<-shapiro.test(residuos)
}
else{
PruebaNormShapiro<-"It was not possible to perform the Shapiro-Wilk normality test, n must be between 3 and 5000"
}

#Sesgo.
Sesgodatos<-c("Skewness",e1071::skewness(residuos,type=2))
Curtosisdatos<-c("Kurtosis",e1071::kurtosis(residuos,type=2))


###############################################
#Seccion que muestra los resultados
###############################################

Resultados<-list("ANOVA ANIDADO", Resumenmodelo,Efectos, PruebaNormLillie,PruebaNormShapiro,PruebaHet,Sesgodatos,Curtosisdatos)


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


maxi<-max(datos[,variables], na.rm = TRUE)
mini<-min(datos[,variables], na.rm = TRUE)

TFac<-2
if(!is.null(FF3)){TFac<-3}
if(!is.null(FF4)){TFac<-4}
NT<-0

datis<-datos[, c(variables,  FF1, FF2)]
NF1<-length(unique(datis[, FF1]))
NF2<-length(unique(datis[, FF2]))
EF1<-unique(datis[, FF1])
EF2<-unique(datis[, FF2])
NF3<-0
NF4<-0

if(!is.null(FF3)){
datis<-datos[, c(variables,  FF1, FF2, FF3)]
NF3<-length(unique(datis[, FF3]))
EF3<-unique(datis[, FF3])
}
if(!is.null(FF4)){ 
datis<-datos[, c(variables,  FF1, FF2, FF3, FF4)]
NF4<-length(unique(datis[, FF4]))
EF4<-unique(datis[, FF4])
}

if(!is.null(FF2)){ NT<-NF1}
if(!is.null(FF3)){ NT<-NF1*NF2}
if(!is.null(FF4)){ NT<-NF1*NF2*NF3}




if(NT>12) combine=FALSE else combine=combine

if(combine==FALSE){


if(!is.null(mfrow)){
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
par(mfrow=mfrow)
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}


if(!is.null(graph1)){

if(!is.null(COLOR1)){
color<-COLOR1
color1<-as.list(COLOR1)
}
else{
color<-terrain.colors(length(unique(datos[,FF1])))
color1<-as.list(color)
}

datos[,FF1]<-factor(datos[,FF1], levels = unique(datos[,FF1]), labels = unique(datos[,FF1]))

if(!is.null(OrderCat1)){
datos[,FF1]<-factor(datos[,FF1], levels = OrderCat1, labels = LabelCat1)
}
else{
if(!is.null(LabelCat1)) datos[,FF1]<-factor(datos[,FF1], levels = unique(datos[,FF1]), labels = LabelCat1) else datos<-datos
}


if(!is.null(PAR1)){
parexe<-paste("par(new,",toString(x=PAR1), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph1=="Boxplot"){

if(!is.null(BOXPLOT1)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF1],",toString(x=BOXPLOT1), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF1],",
"xlab=FF1,", "ylab=variables,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT1)){
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF1],",toString(x=BEANPLOT1), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF1],",
"xlab=FF1,", "ylab=variables,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND1)){
legendexe<-paste("legend(",toString(x=LEGEND1), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS1)){
axisexe<-paste("axis(",toString(x=AXIS1), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT1)){
mtextexe<-paste("mtext(",toString(x=MTEXT1), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT1)){
textexe<-paste("text(",toString(x=TEXT1), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph
else{
}


#Grafico 2


if(!is.null(FF2)){

if(!is.null(graph2)){

if(!is.null(COLOR2)){
color<-COLOR2
color1<-as.list(COLOR2)
}
else{
color<-terrain.colors(length(unique(datos[,FF2])))
color1<-as.list(color)
}

datos[,FF2]<-factor(datos[,FF2], levels = unique(datos[,FF2]), labels = unique(datos[,FF2]))


if(!is.null(OrderCat2)){
datos[,FF2]<-factor(datos[,FF2], levels = OrderCat2, labels = LabelCat2)
}
else{
if(!is.null(LabelCat2)) datos[,FF2]<-factor(datos[,FF2], levels = unique(datos[,FF2]), labels = LabelCat2) else datos<-datos
}


if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()

if(!is.null(PAR2)){
parexe<-paste("par(new,",toString(x=PAR2), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph2=="Boxplot"){

if(!is.null(BOXPLOT2)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF2],",toString(x=BOXPLOT2), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF2],",
"xlab=FF2,", "ylab=variables,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT2)){
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF2],",toString(x=BEANPLOT2), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF2],",
"xlab=FF2,", "ylab=variables,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND2)){
legendexe<-paste("legend(",toString(x=LEGEND2), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS2)){
axisexe<-paste("axis(",toString(x=AXIS2), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT2)){
mtextexe<-paste("mtext(",toString(x=MTEXT2), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT2)){
textexe<-paste("text(",toString(x=TEXT2), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 2
else{
}

}
else{
}#Final FF2


#Grafico 3


if(!is.null(FF3)){

if(!is.null(graph3)){

if(!is.null(COLOR3)){
color<-COLOR3
color1<-as.list(COLOR3)
}
else{
color<-terrain.colors(length(unique(datos[,FF3])))
color1<-as.list(color)
}

datos[,FF3]<-factor(datos[,FF3], levels = unique(datos[,FF3]), labels = unique(datos[,FF3]))


if(!is.null(OrderCat3)){
datos[,FF3]<-factor(datos[,FF3], levels = OrderCat3, labels = LabelCat3)
}
else{
if(!is.null(LabelCat3)) datos[,FF3]<-factor(datos[,FF3], levels = unique(datos[,FF3]), labels = LabelCat3) else datos<-datos
}


if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()

if(!is.null(PAR3)){
parexe<-paste("par(new,",toString(x=PAR3), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph3=="Boxplot"){

if(!is.null(BOXPLOT3)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF3],",toString(x=BOXPLOT3), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF3],",
"xlab=FF3,", "ylab=variables,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT3)){
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF3],",toString(x=BEANPLOT3), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF3],",
"xlab=FF3,", "ylab=variables,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND3)){
legendexe<-paste("legend(",toString(x=LEGEND3), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS3)){
axisexe<-paste("axis(",toString(x=AXIS3), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT3)){
mtextexe<-paste("mtext(",toString(x=MTEXT3), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT3)){
textexe<-paste("text(",toString(x=TEXT3), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 3
else{
}

}
else{
}#Final FF3

if(!is.null(FF4)){

if(!is.null(graph4)){

if(!is.null(COLOR4)){
color<-COLOR4
color1<-as.list(COLOR4)
}
else{
color<-terrain.colors(length(unique(datos[,FF4])))
color1<-as.list(color)
}

datos[,FF4]<-factor(datos[,FF4], levels = unique(datos[,FF4]), labels = unique(datos[,FF4]))


if(!is.null(OrderCat4)){
datos[,FF4]<-factor(datos[,FF4], levels = OrderCat4, labels = LabelCat4)
}
else{
if(!is.null(LabelCat4)) datos[,FF4]<-factor(datos[,FF4], levels = unique(datos[,FF4]), labels = LabelCat4) else datos<-datos
}


if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()

if(!is.null(PAR4)){
parexe<-paste("par(new,",toString(x=PAR4), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph4=="Boxplot"){

if(!is.null(BOXPLOT4)){
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF4],",toString(x=BOXPLOT4), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos[,variables]~datos[,FF4],",
"xlab=FF4,", "ylab=variables,","col=color",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT4)){
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF4],",toString(x=BEANPLOT4), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos[,variables]~datos[,FF4],",
"xlab=FF4,", "ylab=variables,","col=color1",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND4)){
legendexe<-paste("legend(",toString(x=LEGEND4), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS4)){
axisexe<-paste("axis(",toString(x=AXIS4), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT4)){
mtextexe<-paste("mtext(",toString(x=MTEXT4), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT4)){
textexe<-paste("text(",toString(x=TEXT4), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 4
else{
}

}
else{
}#Final FF4

}
else{#EMPIEZA GRAFICO COMBINADO


par(mfrow=c(1,NT))

for (th in TFac){
  if (th==2){

for (i in 1:NF1){
datas<-subset(datis,datis[,FF1]==EF1[i])

if(!is.null(COLOR2)){
color<-COLOR2
color1<-as.list(COLOR2)
}
else{
color<-terrain.colors(length(unique(datas[,FF2])))
color1<-as.list(color)
}

datas[,FF2]<-factor(datas[,FF2], levels = unique(datas[,FF2]), labels = unique(datas[,FF2]))

if(!is.null(OrderCat2)){
datas[,FF2]<-factor(datas[,FF2], levels = OrderCat2, labels = LabelCat2)
}
else{
if(!is.null(LabelCat2)) datas[,FF2]<-factor(datas[,FF2], levels = unique(datas[,FF2]), labels = LabelCat2) else datas<-datas
}


if(!is.null(PAR2)){
parexe<-paste("par(new,",toString(x=PAR2), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,4.2,3,2),cex.lab=1.5)
}

if(graph2=="Boxplot"){

if(!is.null(BOXPLOT2)){
boxplotexe<-paste("boxplot(","datas[,variables]~datas[,FF2],",toString(x=BOXPLOT2), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datas[,variables]~datas[,FF2],",
"xlab=FF2,", "ylab=variables,","col=color,",
"ylim=c(mini,maxi),", "main=EF1[i]",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT2)){
beanplotexe<-paste("beanplot::beanplot(","datas[,variables]~datas[,FF2],",toString(x=BEANPLOT2), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datas[,variables]~datas[,FF2],",
"xlab=FF2,", "ylab=variables,","col=color1,", "main=EF1[i]",")")
eval(parse(text=beanplotexe))
}


}
}


               }
  if (th==3){
for (i in 1:NF1){
datoos<-subset(datis,datis[,FF1]==EF1[i])

for (jjj in 1:NF2){
datas<-subset(datoos,datoos[,FF2]==EF2[jjj])

if(!is.null(COLOR3)){
color<-COLOR3
color1<-as.list(COLOR3)
}
else{
color<-terrain.colors(length(unique(datas[,FF3])))
color1<-as.list(color)
}

datas[,FF3]<-factor(datas[,FF3], levels = unique(datas[,FF3]), labels = unique(datas[,FF3]))

if(!is.null(OrderCat3)){
datas[,FF3]<-factor(datas[,FF3], levels = OrderCat3, labels = LabelCat3)
}
else{
if(!is.null(LabelCat3)) datas[,FF3]<-factor(datas[,FF3], levels = unique(datas[,FF3]), labels = LabelCat3) else datas<-datas
}


if(!is.null(PAR3)){
parexe<-paste("par(new,",toString(x=PAR3), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,4.2,3,2),cex.lab=1.5)
}

if(graph3=="Boxplot"){

if(!is.null(BOXPLOT3)){
boxplotexe<-paste("boxplot(","datas[,variables]~datas[,FF3],",toString(x=BOXPLOT3), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datas[,variables]~datas[,FF3],", "xlab=FF3,", "ylab=variables,",
"col=color,","ylim=c(mini,maxi),", "main=paste(EF1[i],'/',EF2[jjj])",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT3)){
beanplotexe<-paste("beanplot::beanplot(","datas[,variables]~datas[,FF3],",toString(x=BEANPLOT3), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datas[,variables]~datas[,FF3],", "xlab=FF3,", "ylab=variables,",
"col=color1,","main=paste(EF1[i],'/',EF2[jjj])",")")
eval(parse(text=beanplotexe))
}


}

}#Fin del bucle del Factor 2 (jjj)

}#Fin del bucle del Factor 1 (i)

 }

}

}


}
