XI11<-function(data, varY,  varX, offset=NULL,  offsetlog=TRUE,
file="Model predictions.csv", na="NA", dec=",", row.names=FALSE){



########################################################
# Seccin que realiza el procedimiento
########################################################

ModelP<-NULL


datos<-na.exclude(data)


load(file="ModelP.rda")

datos2<-data.frame(datos[,varY],datos[,varX])
colnames(datos2)<-c(varY,varX)

if(!is.null(offset)){
if(offsetlog==TRUE) datos3<-data.frame(datos2,log(datos[, offset])) else datos3<-data.frame(datos2,datos[, offset])
colnames(datos3)<-c(colnames(datos2),offset)

}
else{
datos3<-datos2
}

Pred<-data.frame(datos3[,], predict(ModelP,newdata=datos3, type="response"))
Pred1<-data.frame(datos3[,varY], predict(ModelP,newdata=datos3, type="response"))




names(Pred)<-c(colnames(datos3), "Predicci\u{F3}n")

acierto<-summary(lm(Pred1[,1]~Pred1[,2]))$r.squared 



Resultados<-list("R-squared",acierto)
print(Resultados)

if(dec=="."){
write.csv(x=Pred ,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = Pred ,file = file, fileEncoding = "", row.names=row.names,na=na)
}


}
