XI4<-function(data, variables, threshold=10, varCode=NULL, 
 file1="VIF.csv",  file2="Variables.csv", na="NA", dec=",", row.names=FALSE){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datos1<-na.exclude(subset(datos,selec=variables))

###############################################
#Seccin que muestra los resultados
###############################################

#Colinearity
VIF<-usdm::vifstep(datos1, th=500)

VIF<-attributes(VIF)
VIF<-VIF$results

VIF<-VIF[which(VIF[,2]>threshold),]
print(VIF)

datos3<-subset(datos, select=as.character(unique(VIF[,1])))


if(dec=="."){
write.csv(x=VIF,file = file1, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = VIF,file= file1, fileEncoding = "", row.names=row.names,na=na)
}




if(!is.null(varCode)){
datos2<-subset(datos, select=varCode)
datos3<-data.frame(datos2,datos3)
}

if(dec=="."){
write.csv(x=datos3,file= file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = datos3,file = file2, fileEncoding = "", row.names=row.names,na=na)
}



}