XII4<-function(data, event.e, n.e, event.c, n.c, studlab,
META=NULL, FUNNEL=NULL, LEGEND=NULL,
COLOR=c("#FFF68FFF", "#FFA54FFF", "#FF6347FF"), file="Output.txt"){





###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datos<-na.exclude(datos)



#Calculo del meta-anlisis
if(!is.null(META)){
metaexe<-paste("meta::metabin(","event.e=datos[,event.e],", "n.e=datos[,n.e],", "event.c=datos[,event.c],",
 "n.c=datos[,n.c],","studlab=datos[,studlab],",toString(x=META), ")")
meta<-eval(parse(text=metaexe))
}
else{
metaexe<-paste("meta::metabin(","event.e=datos[,event.e],", "n.e=datos[,n.e],", "event.c=datos[,event.c],",
 "n.c=datos[,n.c],","studlab=datos[,studlab],","sm='OR',", "method='MH',", "print.CMH=TRUE",")")
meta<-eval(parse(text=metaexe))
}



#Diagrama de embudo

if(!is.null(FUNNEL)){
funnelexe<-paste("meta::funnel.meta(","meta,",toString(x=FUNNEL), ")")
eval(parse(text=funnelexe))
}
else{
funnelexe<-paste("meta::funnel.meta(","meta,", "comb.fixed=TRUE,", "level=0.95,", "contour.levels=c(0.9, 0.95, 0.99),",
"col.contour=COLOR,", "studlab=TRUE,", "xlab=NULL,", "ylab=NULL,", "font.lab=2,", "cex.lab=1.6,",  "cex.axis=1.2,",
"main=NULL,", "cex.main=1.8",")")
eval(parse(text=funnelexe))
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
legendexe<-paste("legend(","x='topright',", "legend=c('0.1 > p > 0.05', '0.05 > p > 0.01', '0.01 > p > 0'),",
 "fill=COLOR,", "bty='n'", ")")
eval(parse(text=legendexe))
}








Resultados<-list(meta)


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}




}
