XII5<-function(data, event.e, n.e, event.c, n.c, studlab, META=NULL,
FOREST=NULL, file="Output.txt"){




###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datos<-na.exclude(datos)



#Calculo del meta-anlisis
if(!is.null(META)){
metaexe<-paste("meta::metabin(","event.e=datos[,event.e],", "n.e=datos[,n.e],", "event.c=datos[,event.c],",
 "n.c=datos[,n.c],","studlab=datos[,studlab],",toString(x=META), ")")
meta<-eval(parse(text=metaexe))
}
else{
metaexe<-paste("meta::metabin(","event.e=datos[,event.e],", "n.e=datos[,n.e],", "event.c=datos[,event.c],",
 "n.c=datos[,n.c],","studlab=datos[,studlab],","sm='OR',", "method='MH',", "print.CMH=TRUE",")")
meta<-eval(parse(text=metaexe))
}

meta1<-meta::metainf(meta, pooled="random")

#Diagrama de anlisis de sensibilidad

if(!is.null(FOREST)){
forestexe<-paste("meta::forest.meta(","meta1,",toString(x=FOREST), ")")
eval(parse(text=forestexe))
}
else{
forestexe<-paste("meta::forest.meta(","meta1,", "text.fixed = 'Fixed effect model',","text.random= 'Random effects model',",
"pooled.totals=TRUE,","pooled.events=TRUE,","xlab=NULL,","xlim=NULL,",
"leftcols=NULL,","leftlabs=NULL,","rightcols=NULL,","rightlabs=NULL,",
"lab.e=NULL,","lab.c=NULL,","hetlab=NULL,","addspace=FALSE,",
"col.square='red',","col.diamond='blue',","fs.xlab=14,","ff.xlab=2",")")
eval(parse(text=forestexe))
}


Resultados<-list(meta1)


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}




}
