XIV4<-function(data, var, cat=NULL, ResetPAR=TRUE, PAR=NULL,
HCLUST=NULL, PLOT1=NULL, PLOT2=NULL, LEGEND=NULL,
AXIS=NULL, MTEXT= NULL, TEXT=NULL){



###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=var))

if(!is.null(cat)){
datosT<-data.frame(subset(datos, select=cat), subset(datos, select=var))
}

datos<-na.exclude(datosT)



if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2,cex.lab=1.5, cex.main=1.7)
}


datos1<-data.frame(subset(datos, select=var))



if(!is.null(HCLUST)){
hclustexe<-paste("hclust(","d=dist(datos1, method='euclidea'),",toString(x=HCLUST), ")")
hc<-eval(parse(text=hclustexe))
}
else{
hclustexe<-paste("hclust(","d=dist(datos1, method='euclidea'),", ")")
hc<-eval(parse(text=hclustexe))
}

if(!is.null(cat)){
if(!is.null(PLOT1)){
hclustexe<-paste("plot(","x=hc,","label=datos[,cat],", toString(x=PLOT1), ")")
eval(parse(text=hclustexe))
}
else{
hclustexe<-paste("plot(","x=hc,","label=datos[,cat],", "xlab='',", "sub='',", ")")
eval(parse(text=hclustexe))
}
}
else{
if(!is.null(PLOT2)){
hclustexe<-paste("plot(","x=hc,", toString(x=PLOT2), ")")
eval(parse(text=hclustexe))
}
else{
hclustexe<-paste("plot(","x=hc,", "xlab='',", "sub='',", ")")
eval(parse(text=hclustexe))
}
}



if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}

if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}




}
