XV3<-function(data, cat, var, resp, start=NULL, nsubsets=20, ResetPAR=TRUE, PAR=NULL,
PLOT=NULL, YLAB=NULL, XLAB=NULL, CEXPCH=1,
COLABLINE="black", COLOR="black", PCH=15, file1="Test.csv",
file2="Coefficients.csv", na="NA", dec=",", row.names=FALSE){


randomRows = function(df,n, file="Random.csv"){
randomrows<-df[sample(nrow(df),n),]
if(dec==","){
write.csv2(randomrows,file,row.names=FALSE)
}
else{
write.csv(randomrows,file,row.names=FALSE)
}
}

ZZ<-matrix(c("","","",""), nrow=2)


categ<-length(unique(as.character(data[,cat])))
dimI<-dim(data)

if(is.null(start)){
n<-categ*7
}
else{
n<-start
}



ZZ[1,1]<-paste("Subset of",n,"samples of",dimI[1])
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
xxx<-0
while(xxx==0){
randomRows(df=data, n=n, file="Random.csv")
if(dec=="."){
dataR<-read.csv("Random.csv",header=TRUE,encoding="latin1")
}
else{
dataR<-read.csv2("Random.csv",header=TRUE,encoding="latin1")
}

if(length(unique(as.character(dataR[,cat])))==categ){
xxx<-1
}
}
xxx<-0
StatR::XI6(data = dataR , cat = cat, var = var, resp = resp , cart = FALSE, stepwise=FALSE, dec=dec, row.names=row.names)


StatR::XI7(data = data , cat = cat, resp = resp, dec=dec, row.names=row.names)

if(dec=="."){
dati<-read.csv("Model predictions.csv",header=TRUE,encoding="latin1")
}
else{
dati<-read.csv2("Model predictions.csv",header=TRUE,encoding="latin1")
}
le<-length(which(dati[,cat]==dati[,"Predictions"]))
por<-le*100/dimI[1]
final<-data.frame(n,por)



int<-floor((dimI[1]-n)/nsubsets)


for(zz in 1:nsubsets){
n<-n+int

ZZ[1,1]<-paste("Subset of",n,"samples of",dimI[1])
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
xxx<-0
while(xxx==0){
randomRows(df=data, n=n, file="Random.csv")
if(dec=="."){
dataR<-read.csv("Random.csv",header=TRUE,encoding="latin1")
}
else{
dataR<-read.csv2("Random.csv",header=TRUE,encoding="latin1")
}

if(length(unique(as.character(dataR[,cat])))==categ){
xxx<-1
}
}
xxx<-0
StatR::XI6(data = dataR , cat = cat, var = var, resp = resp , cart = FALSE, stepwise=FALSE, dec=dec, row.names=row.names)


StatR::XI7(data = data , cat = cat, resp = resp, dec=dec, row.names=row.names)

if(dec=="."){
dati<-read.csv("Model predictions.csv",header=TRUE,encoding="latin1")
}
else{
dati<-read.csv2("Model predictions.csv",header=TRUE,encoding="latin1")
}
le<-length(which(dati[,cat]==dati[,"Predictions"]))
por<-le*100/dimI[1]
te<-data.frame(n,por)
final<-rbind(final,te)

}

if(dec=="."){
write.csv(x = final,file = file1, fileEncoding = "", row.names=row.names, na=na)
}
else{
write.csv2(x = final,file = file1, fileEncoding = "", row.names=row.names, na=na)
}

if(is.null(XLAB)){
XLAB = "Number of samples"
}

if(is.null(YLAB)){
YLAB = "Identification success (%)"
}


StatR::XI2(data = final , varX = "n" , varY = "por" , resPlot = FALSE ,
XLAB = XLAB , YLAB = YLAB , model =c("Clench","Nexponential", "Saturation","Rational") , mfrow = c(2,2),
ResetPAR=ResetPAR, PAR=PAR,  PLOT=PLOT, CEXPCH=CEXPCH,
COLABLINE=COLABLINE, COLOR=COLOR, PCH=PCH,
file2=file2, na=na, dec=dec, row.names=row.names)

if(dec=="."){
dati<-read.csv(file2,header=TRUE,encoding="latin1")
}
else{
dati<-read.csv2(file2,header=TRUE,encoding="latin1")
}


print("ASYMPTOTIC VALUE OF ACCUMULATION CURVES")

which(as.character(dati[,1]) == "Clench")

print("Clench")
if(any(as.character(dati[,1])=="Clench")){
row<-which(as.character(dati[,1]) == "Clench")
print(dati[row,2]/dati[row,3])
}
else{
print("It could not be estimated")
}

print("Nexponential")
if(any(dati[,1]=="Nexponential")){
row<-which(as.character(dati[,1]) == "Nexponential")
print(dati[row,2])
}
else{
print("It could not be estimated")
}


print("Saturation")
if(any(dati[,1]=="Saturation")){
row<-which(as.character(dati[,1]) == "Saturation")
print(dati[row,2])
}
else{
print("It could not be estimated")
}

print("Rational")
if(any(dati[,1]=="Rational")){
row<-which(as.character(dati[,1]) == "Rational")
print(dati[row,3]/dati[row,4])
}
else{
print("It could not be estimated")
}

}

