XVI1<-function(data, var, Factor, SS="III", trans=NULL, pthreshold=0.05, psig=FALSE, ellipse=FALSE, convex=TRUE, PCH=rep(16,100),
order=TRUE, cor=TRUE, file1="Output.txt", file2="Multinormality.csv", file3="Post hoc pvalues.csv", na="NA", dec=",", row.names=TRUE){


####Function intercect

intersect_all <- function(a,b,...){
  Reduce(intersect, list(a,b,...))
}

####End Intersect

####Function to order variables

ordenar<-function(datos, Factor, var, dec=","){

if(class(datos[,Factor])=="factor"){
dati<-as.character(unique(datos[,Factor]))
}
else{
dati<-unique(datos[,Factor])
}

catnn<-length(unique(dati))


catn<-length(var)
g<-0

for(q in 1:catn){

maxden<-0

for(pp in 1:catnn){
datos3<-subset(datos, datos[,Factor]==dati[pp])
den<-density(datos3[,var[q]], kernel="gaussian")
maxd<-max(den$y)
if(maxd>maxden) maxden<-maxd else maxden<-maxden
}



Variable1<-"M"
Overlap<-1
Variable2<-"M"


minimo<-min(datos[,var[q]], na.rm=TRUE)
maximo<-max(datos[,var[q]], na.rm=TRUE)

Variable1<-"M"
Overlap<-1
Variable2<-"M"

for(h in 1:catnn){
datos3<-subset(datos, datos[,Factor]==dati[h])
d1<-density(datos3[,var[q]], from=minimo, to=maximo, kernel="gaussian")
for(i in 1:catnn){
datos3<-subset(datos, datos[,Factor]==dati[i])
d2<-density(datos3[,var[q]], from=minimo, to=maximo, kernel="gaussian")
p<-d1$y-d2$y
p[which(p<0)]=0
p3<-d1$y-p
p3[which(p3<0)]=0
auc1<-kulife::auc(d1$x,d1$y)
auc3<-kulife::auc(d1$x,p3)
P1<-auc3*100/auc1
if(dati[h]==dati[i]){
}
else{
Variable1<-append(Variable1,dati[h])
Variable2<-append(Variable2,dati[i])
Overlap<-append(Overlap,P1)
}
}

salida<-data.frame(Variable1[-1],Overlap[-1],Variable2[-1])

dims<-dim(salida)

rep<-rep(var[q], dims[1])

salida<-data.frame(Variable1[-1],Overlap[-1],Variable2[-1], rep)

colnames(salida)<-c("Variable1","Overlap","Variable2","Variable")

if(g==0){
selvar<-salida
g<-1
}
else{
selvar<-rbind(selvar, salida)
}

}####End for catnn

if(dec=="."){
write.csv(x=selvar,file = "selvar.csv",  fileEncoding = "", row.names=FALSE)
}
else{
write.csv2(x=selvar,file = "selvar.csv",  fileEncoding = "", row.names=FALSE)
}

}

}####End function ordenar


####FUNCTION POLAR COORDINATES

PC<-function(data, variables, group=NULL, cor=TRUE, ellipse=FALSE, convex=FALSE, SCATTERPLOT=NULL, 
 XLAB=NULL, YLAB=NULL, XLIM=NULL, YLIM=NULL, PCH=NULL, COLOR=NULL, 
LEGEND=NULL, arrows=TRUE, larrow=1, ARROWS=NULL, TEXTa=NULL, 
file="Polar coordinates.csv", na="NA", dec=",", row.names=FALSE){


if(is.null(group) & (ellipse==TRUE | convex==TRUE)) {
stop("It is necessary to specify the group")
}


#Polar coordinates

n<-length(variables)

datos<-data

var<-variables



if(!is.null(group)){
datosT<-data.frame(subset(datos, select=group), subset(datos, select=var))
datos<-na.exclude(datosT)
dati<-as.character(unique(datos[,1]))
}
else{
datosT<-subset(datos, select=var)
datos<-na.exclude(datosT)
}







#Organize by correlation

selection<-subset(datos, select=var)


dimdt<-dim(selection)

if(cor==TRUE){
if(dimdt[2]>3){
datosT2<-selection
datosT3<-selection[,1]

names<-names(selection)[1]

for(zz in 1:(dimdt[2]-2)){
cor<-cor(datosT2)
corT1<-cor[,-1]
datosT2<-datosT2[,-1]

df<-which.max(cor[!cor[,1]==1,1])

if(zz==(dimdt[2]-2)){
dimdim<-dim(datosT3)
cor1<-cor(datosT3[,dimdim[2]], datosT2[,1])
cor2<-cor(datosT3[,dimdim[2]], datosT2[,2])
if(cor1>cor2){
datosT3<-data.frame(datosT3, datosT2[,1],datosT2[,2])
names(datosT3)<-c(names,names(datosT2))
}
else{
datosT3<-data.frame(datosT3, datosT2[,2],datosT2[,1])
kk<-datosT2
kk<-data.frame(datosT2[,2],datosT2[,1])
names(kk)<-c(names(datosT2)[2],names(datosT2)[1])
names(datosT3)<-c(names,names(kk))
} 

}
else{
datosT3<-data.frame(datosT3, datosT2[,df])
names(datosT3)<-c(names,names(datosT2)[df])
}

names<-names(datosT3)


datosP<-datosT2[,-df]


datosZZZ<-datosT2
datosT2<-data.frame(datosT2[,names(datosT2)[df]], datosP)
names(datosT2)<-c(names(datosZZZ)[df], colnames(datosP))
}

selection<-datosT3
}

var<-colnames(selection)
}#end cor



#Standardization 1 to -1

a<-dim(selection)

datosE<-selection

for (z in 1:a[2]){
matrixE<-matrix(c(-1, 1, min(selection[,z],na.rm=TRUE),max(selection[,z],na.rm=TRUE)), nrow = 2 , ncol = 2)
reg<-lm(matrixE[,1]~matrixE[,2])
datosC<-reg$coefficients[1]+selection[,z]*reg$coefficients[2]
datosE<-cbind(datosE,datosC)
}


datosE<-datosE[,-c(1:a[2])]


colnames(datosE)<-colnames(selection)

selection<-datosE


#Estimation of polar coordinates

angle<-360/((a[2])*2)*0.0174532925


datosX<-selection[,1]
h<-0
for (z in 1:a[2]){
h<-h+1
datosC<- ifelse(selection[,z] <=0, abs(selection[,z])*cos(angle*h+180*0.0174532925), abs(selection[,z])*cos(angle*h)) 
datosX<-data.frame(datosX,datosC)
}
datosX<-datosX[,-1]

XX<-apply(datosX,1,sum)


RX<-(max(XX)-min(XX))


datosY<-selection[,1]
h<-0
for (z in 1:a[2]){
h<-h+1
datosC<- ifelse(selection[,z] <=0, abs(selection[,z])*sin(angle*h+180*0.0174532925), abs(selection[,z])*sin(angle*h)) 
datosY<-cbind(datosY,datosC)
}

datosY<-datosY[,-1]

YY<-apply(datosY,1,sum)

RY<-(max(YY)-min(YY))

if(!is.null(group)){
datosF<-data.frame(datos[,1],XX,YY)
colnames(datosF)<-c("Group","X","Y")
}
else{
datosF<-data.frame(XX,YY)
colnames(datosF)<-c("X","Y")
}


if(dec=="."){
write.csv(x=datosF,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = datosF,file = file, fileEncoding = "", row.names=row.names,na=na)
}


if(dec=="."){
datosF<-read.csv(file=file ,header=TRUE)
}
else{
datosF<-read.csv2(file=file ,header=TRUE)
}



if(!is.null(group)){

datosF<-datosF[order(datosF[,1]), ]

#####convex
if(!is.null(COLOR)){
color1<-COLOR
}
else{
if(convex==TRUE) color1<-rainbow(length(unique(datosF[,1])), alpha=0.4) else color1<-rainbow(length(unique(datosF[,1])))
}
#######



catn<-length(unique(datosF[,1]))

pch1<-14+1
for (t in 2:catn){
pcht<-14+t
pch1<-append(pch1,pcht)
}

if(!is.null(PCH)) pcht<-PCH else pcht<-pch1

}

else{

if(!is.null(COLOR)) color1<-COLOR else color1<-"black"

if(!is.null(PCH)) pcht<-PCH else pcht<-15

}



if(!is.null(XLAB)) xlab<-XLAB else xlab<-"POLAR COORDINATES X"


if(!is.null(YLAB)){
ylab<-YLAB
}
else{
ylab<-"POLAR COORDINATES Y"
}

par(mfont.lab=2, mar=c(5,5,3,2),cex.lab=1.5)


if(!is.null(group)){
datosF[,1]<-as.factor(datosF[,1])
by.groups<-TRUE
if(!is.null(SCATTERPLOT)){
scatterplotexe<-paste("car::scatterplot(","Y~X| Group,", "data=datosF,", toString(x=SCATTERPLOT), ")")
eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("car::scatterplot(","Y~X| Group,", "data=datosF,", "regLine=FALSE,",
"smooth=FALSE,", "spread=FALSE,", "span= 1," ,"grid=FALSE,", "xlab=xlab,","ylab=ylab,","xlim=XLIM,","ylim=YLIM,",
"boxplots=FALSE,", "by.groups=by.groups,", "ellipse=ellipse,", "col=color1,", "pch=pcht,","legend=list(coords=c(x=500000000,y=500000000))", ")")
eval(parse(text=scatterplotexe))
}
}

else{
by.groups<-FALSE
if(!is.null(SCATTERPLOT)){
scatterplotexe<-paste("car::scatterplot(","Y~X,", "data=datosF,", toString(x=SCATTERPLOT), ")")
eval(parse(text=scatterplotexe))
}
else{
scatterplotexe<-paste("car::scatterplot(","Y~X,", "data=datosF,", "regLine=FALSE,",
"smooth=FALSE,", "spread=FALSE,", "span= 1," ,"grid=FALSE,", "xlab=xlab,","ylab=ylab,","xlim=XLIM,","ylim=YLIM,",
"boxplots=FALSE,", "by.groups=by.groups,", "ellipse=ellipse,", "col=color1,", "pch=pcht,","legend=list(coords=c(x=500000000,y=500000000))", ")")
eval(parse(text=scatterplotexe))
}

}

dati<-as.character(unique(datosF[,1]))

####Convex
if(!is.null(group)){
if(convex==TRUE){
for(zz in 1:catn){
datis<-subset(datosF,(Group == dati[zz]))
hpts <- chull(x=datis[,"X"], y=datis[,"Y"])
hpts <- c(hpts, hpts[1])
datiss<-datis[hpts,]
polygon(datiss[,2],datiss[,3], col=color1[zz], border=NA)
}
}
}
####


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
if(!is.null(group)){
legendexe<-paste("legend(","x='topleft',","legend=unique(datosF[,'Group']),", "bty='n',", "col=color1,",
"pch=pcht", ")")
eval(parse(text=legendexe))
}
}


#ARROWS

if(!is.null(XLIM)){
minsx<-XLIM[1]
maxsx<-XLIM[2]
}
else{
if(!is.null(group)){
minsx<-min(datosF[,2])
maxsx<-max(datosF[,2])
}
else{
minsx<-min(datosF[,1])
maxsx<-max(datosF[,1])
}
}

if(!is.null(YLIM)){
minsy<-YLIM[1]
maxsy<-YLIM[2]
}
else{
if(!is.null(group)){
minsy<-min(datosF[,3])
maxsy<-max(datosF[,3])
}
else{
minsy<-min(datosF[,2])
maxsy<-max(datosF[,2])
}
}

meanx<-(minsx+maxsx)/2
meany<-(minsy+maxsy)/2

minar<-min((maxsy-minsy),(maxsx-minsx))/4

dima<-length(var)

angle<-360/((dima)*2)*0.0174532925


if(arrows==TRUE){
for(aa in 1:dima){
ag<-angle*aa
x2<-minar*cos(ag)*larrow+meanx
y2<-minar*sin(ag)*larrow+meany
if(!is.null(ARROWS)){
arrowsexe<-paste("IDPmisc::Arrows(","x1=meanx,", "y1=meany,", "x2=-x2,", "y2=y2,", toString(x=ARROWS), ")")
eval(parse(text=arrowsexe))
}
else{
arrowsexe<-paste("IDPmisc::Arrows(","x1=meanx,", "y1=meany,", "x2=x2,", "y2=y2,", "open=FALSE", ")")
eval(parse(text=arrowsexe))
}

if(!is.null(TEXTa)){
textexe<-paste("text(","x=x2,", "y=y2,", "labels = paste('+',var[aa], sep=''),", "pos=3,", toString(x=TEXTa), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=x2,", "y=y2,", "labels = paste('+',var[aa], sep=''),", "pos=3", ")")
eval(parse(text=textexe))
}

}#END BUCLE arrows

for(aa in 1:dima){
ag<-angle*aa
x2<-minar*cos(ag+180*0.0174532925)*larrow+meanx
y2<-minar*sin(ag+180*0.0174532925)*larrow+meany
if(!is.null(ARROWS)){
arrowsexe<-paste("IDPmisc::Arrows(","x1=meanx,", "y1=meany,", "x2=-x2,", "y2=y2,", toString(x=ARROWS), ")")
eval(parse(text=arrowsexe))
}
else{
arrowsexe<-paste("IDPmisc::Arrows(","x1=meanx,", "y1=meany,", "x2=x2,", "y2=y2,", "open=FALSE", ")")
eval(parse(text=arrowsexe))
}

if(!is.null(TEXTa)){
textexe<-paste("text(","x=x2,", "y=y2,", "labels = paste('-',var[aa], sep=''),", "pos=1,", toString(x=TEXTa), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=x2,", "y=y2,", "labels = paste('-',var[aa], sep=''),", "pos=1", ")")
eval(parse(text=textexe))
}

}#END BUCLE arrows

}#END arrows TRUE





}

####End Polar coordinates


####Selection of data

datos<-data

datosT<-data.frame(subset(datos, select=var), subset(datos, select=Factor))
datos<-na.exclude(datosT)

datos1<-as.data.frame(subset(datos, select=var))

datos2<-as.data.frame(subset(datos, select=Factor))

ph<-NULL

####Transformation of fata

if(!is.null(trans)){

if(trans=="1/x2"){
datos1<-1/(datos1^2)
}

if(trans=="1/x"){
datos1<-1/(datos1)
}

if(trans=="LN"){
datos1<-log(datos1)
}

if(trans=="LOG"){
datos1<-log10(datos1)
}

if(trans=="SQR"){
datos1<-sqrt(datos1)
}

if(trans=="x2"){
datos1<-datos1^2
}

if(trans=="x3"){
datos1<-datos1^3
}

if(trans=="EXP"){
datos1<-exp(datos1)
}

if(trans=="ASN"){
datos1<-acos(datos1)
}

datos<-data.frame(datos1,datos2)

}


####Formula

zz1<-dim(datos1)
fo1<-names(datos1)[1]
if(zz1[2]>1){
for(i in 2:zz1[2]){
fo1<-paste(fo1, ",", names(datos1)[i])
}
}

zz2<-dim(datos2)
fo2<-names(datos2)[1]
if(zz2[2]>1){
for(i in 2:zz2[2]){
fo2<-paste(fo2, "*", names(datos2)[i])
}
}

fo<-paste("cbind(",fo1,")","~",fo2)

mod<-lm(fo, data=datos)


####Correlation

VIF<-usdm::vif(datos1)


#Residuals

Residuals<-residuals(mod)

residuals<-data.frame(Residuals,datos2)

#####Multinormality

va<-0
for(hh in 1:zz1[2]){
for(kk in 1:zz2[2]){
uni<-as.character(unique(residuals[,Factor[kk]]))

lenh<-length(uni)
for(tt in 1:lenh){
datar<-subset(residuals,(residuals[,Factor[kk]] == uni[tt]))
dimr<-dim(datar)

if(dimr[1]>4){

if(va==0){
va<-1
L<-nortest::lillie.test(datar[,var[hh]])
S<-shapiro.test(datar[,var[hh]])
pvalues<-data.frame(var[hh],Factor[kk],uni[tt],S$p.value,L$p.value)
colnames(pvalues)<-c("Variable", "Factor", "Group", "p.Shapiro", "p.Lillie")
}
else{
L<-nortest::lillie.test(datar[,var[hh]])
S<-shapiro.test(datar[,var[hh]])
p<-data.frame(var[hh],Factor[kk],uni[tt],S$p.value,L$p.value)
colnames(p)<-c("Variable", "Factor", "Group", "p.Shapiro", "p.Lillie")
pvalues<-rbind(pvalues,p)
}
}

else{

if(va==0){
va<-1

pvalues<-data.frame(var[hh],Factor[kk],uni[tt],NA,NA)
colnames(pvalues)<-c("Variable", "Factor", "Group", "p.Shapiro", "p.Lillie")
}
else{
p<-data.frame(var[hh],Factor[kk],uni[tt],NA,NA)
colnames(p)<-c("Variable", "Factor", "Group", "p.Shapiro", "p.Lillie")
pvalues<-rbind(pvalues,p)
}

}



}
}
}

####Box's M-Test

Resultados<-list( VIF,  "Box's M-Test")

for(ff in 1:zz2[2]){
boxM<-heplots::boxM(Residuals, datos2[,ff])
if(ff==1) BOX<-list(names(datos2[ff]), boxM) else BOX<-list(BOX, names(datos2[ff]), boxM)
}

###MANOVA

if(SS=="I"){
MANOVA<-manova(mod)
s1<-summary(MANOVA)
s2<-summary(MANOVA, test="Wilks")
s3<-summary(MANOVA, test="Roy")
s4<-summary(MANOVA, test="Hotelling-Lawley")
MANOVA1<-c(s1,s2,s3,s4)
}


if(SS=="II" | SS=="III"){
MANOVA<-car::Manova(mod, type=SS, data=datos)
sum<-summary(MANOVA)
MANOVA1<-sum$multivariate.tests
}


####Plots


for(ff in 1:zz2[2]){
text<-as.character(Factor[ff])
len<-length(unique(datos[,text]))
COLOR<-topo.colors(n=len, alpha=0.7)
if(ff>1){
dev.new()
}

if(order==TRUE){
ordenar(datos=datos, Factor=text, var=var, dec=dec)

if(dec=="."){
selvar<-read.csv("selvar.csv", dec=dec)
}
else{
selvar<-read.csv2("selvar.csv",dec=dec)
}

selvar<-selvar[order(selvar[,2]),]

var1<-as.character(unique(selvar[,4]))

if(file.exists("selvar.csv")){
file.remove("selvar.csv")
}
}
else{
var1<-var
}



PC(data = datos , variables = var1 , group = text , ellipse=ellipse, convex = convex, COLOR=COLOR, PCH=PCH, dec=dec, cor=cor)
mtext(text = text , line = 1 , cex = 2 , font = 2)

}

####Post hoc

val<-0

for(hh in 1:zz2[2]){
uni<-as.character(unique(datos[,Factor[hh]]))
fo<-paste("cbind(",fo1,")","~",Factor[hh])
len<-length(uni)

if(len>2){
for(kk in 1:len){
if(kk<len){
for(tt in (kk+1):len){

datis<-subset(datos, (datos[,Factor[hh]] == uni[kk]) |  (datos[,Factor[hh]] == uni[tt]))

fo<-paste("cbind(",fo1,")","~",Factor[hh])
mod<-lm(fo, data=datis)


if(SS=="I"){
MANOVA<-manova(mod)
s1<-summary(MANOVA)

if(val==0){
ph<-data.frame(Factor[hh],uni[kk], uni[tt], s1$stats[1,6])
colnames(ph)<-c("Factor", "Group1", "Group2", "p.values")
val<-1
}
else{
pp<-data.frame(Factor[hh],uni[kk], uni[tt], s1$stats[1,6])
colnames(pp)<-c("Factor", "Group1", "Group2", "p.values")
ph<-rbind(ph, pp)
}
}


if(SS=="II" | SS=="III"){
av <- anova(mod)
pv<-av$"Pr(>F)"

if(val==0){
ph<-data.frame(Factor[hh],uni[kk], uni[tt], pv[2])
colnames(ph)<-c("Factor", "Group1", "Group2", "p.values")
val<-1
}
else{
pp<-data.frame(Factor[hh],uni[kk], uni[tt], pv[2])
colnames(pp)<-c("Factor", "Group1", "Group2", "p.values")
ph<-rbind(ph, pp)
}
}



}
}
}
}
}


####Results

Resultados<-list( VIF, "Box's M-Test", BOX, "MANOVA", MANOVA1)

if(dec=="."){
write.csv(x=pvalues,file = file2, fileEncoding = "", row.names=FALSE,na=na)
}
else{
write.csv2(x = pvalues,file = file2, fileEncoding = "", row.names=FALSE,na=na)
}


####Plots Post hoc

if(!is.null(ph)){

ph<-na.exclude(ph)

if(psig==TRUE){
ph<-ph[which(ph[,4]<pthreshold),]
}

if(dec=="."){
write.csv(x=ph,file = file3, fileEncoding = "", row.names=FALSE,na=na)
}
else{
write.csv2(x = ph,file = file3, fileEncoding = "", row.names=FALSE,na=na)
}

phzz<-ph[which(ph[,4]<pthreshold),]

dimph<-dim(phzz)

if(dimph[1]>2){

fac<-as.character(unique(ph[,1]))
len<-length(fac)

for(ff in 1:len){

catg<-as.character(unique(datos[,fac[ff]]))
lenc<-length(catg)
ma<-as.data.frame(matrix(0,length(catg),length(catg)+1))
colnames<-c(catg, "Group")
names(ma)<-colnames
ma[,"Group"]<-catg

if(dec=="."){
ph<-read.csv(file = file3, fileEncoding = "")
}
else{
ph<-read.csv2(file = file3, fileEncoding = "")
}


for(yy in 1:lenc){
dat1<-subset(ph, (ph[,"Factor"]==fac[ff]) & (ph[,"Group1"]==catg[yy]) & (p.values< pthreshold) )
dat2<-subset(ph,(ph[,"Factor"]==fac[ff]) & (ph[,"Group2"]==catg[yy]) & (p.values< pthreshold) )
list<-unique(append(dat1[,3],dat2[,2]))
co<-match(list,colnames)
if(length(co[!is.na(co)])>0){
ma[yy,co]<-1
}
}

hc<-hclust(d=dist(ma[,1:lenc], method='euclidea'))




k<-1
verdad<-FALSE

while(verdad==FALSE){

k<-k+1

if(k>lenc){
verdad<-TRUE
k<-lenc
}
else{
val<-0

Cluster <- cutree(hc, k=k)

m<-data.frame(Factor=catg,Cluster) 
m<-m[order(m[,1]),]
names(m)<-c(fac[ff],"Cluster")

datus<-merge(datos,m)


for(kk in 1:k){
if(kk<k){
for(tt in (kk+1):k){
datis<-subset(datus, (datus[,"Cluster"] == kk) |  (datus[,"Cluster"] == tt))

fo<-paste("cbind(",fo1,")","~","Cluster")
mod<-lm(fo, data=datis)


if(SS=="I"){
MANOVA<-manova(mod)
s1<-summary(MANOVA)

if(val==0){
phh<-data.frame(kk, tt, s1$stats[1,6])
colnames(phh)<-c("Group1", "Group2", "p.values")
val<-1
}
else{
pp<-data.frame(kk, tt, s1$stats[1,6])
colnames(pp)<-c("Group1", "Group2", "p.values")
phh<-rbind(phh, pp)
}
}


if(SS=="II" | SS=="III"){
av <- anova(mod)
pv<-av$"Pr(>F)"

if(val==0){
phh<-data.frame(kk, tt, pv[2])
colnames(phh)<-c("Group1", "Group2", "p.values")
val<-1
}
else{
pp<-data.frame(kk, tt, pv[2])
colnames(pp)<-c("Group1", "Group2", "p.values")
phh<-rbind(phh, pp)
}
}

}
}
}
verdad<-any(phh[,3]>pthreshold)
}####End if k

}####End while

names(m)<-c(fac[ff], "Cluster")



dat1<-subset(phh,(p.values>= pthreshold) )

dimd<-dim(dat1)
if(dimd[1]>0){
for(vv in 1:dimd[1]){
m[,2]<-replace(m[,2], m[,2]==dat1[vv,2], dat1[vv,1])
}

cl<-unique(m[,2])
lcl<-length(cl)
cl1<-seq(1, lcl, 1)

for(vv in 1:lcl){
m[,2]<-replace(m[,2], m[,2]==cl[vv], cl1[vv])
}
}

datis<-merge(datos,m)


text<-paste("Post hoc:", fac[ff])

COLOR<-topo.colors(n=k, alpha=0.7)

dev.new()

if(order==TRUE){
ordenar(datos=datis, Factor="Cluster", var=var, dec=dec)

if(dec=="."){
selvar<-read.csv("selvar.csv", dec=dec)
}
else{
selvar<-read.csv2("selvar.csv",dec=dec)
}

selvar<-selvar[order(selvar[,2]),]

var1<-as.character(unique(selvar[,4]))

if(file.exists("selvar.csv")){
file.remove("selvar.csv")
}
}
else{
var1<-var
}



PC(data = datis , variables = var1 , group = "Cluster" , ellipse=ellipse, convex = convex, COLOR=COLOR, PCH=PCH, dec=dec, cor=cor)
mtext(text = text , line = 1 , cex = 2 , font = 2)

datis<-data.frame(datis[,fac[ff]], datis[,"Cluster"])

datis<-datis[!duplicated(datis),  ]
names(datis)<-c(fac[ff],"Cluster")
Resultados<-list(Resultados, paste("Post hoc groups:", fac[ff]), datis)

}####End dimph
}
}####En NULL ph



#####Interaction Plots

lenF<-length(Factor)

if(lenF>1){

for(zz in 1:lenF){
if(zz<lenF){
for(tt in (zz+1):lenF){
NF<-paste(datos[,Factor[zz]],datos[,Factor[tt]], sep="-")
datis<-data.frame(datos,NF)
NFA<-paste(Factor[zz], Factor[tt], sep="-")
text<-paste("Int. Plot:", NFA)
len<-length(unique(as.character(datis[,"NF"])))
COLOR<-topo.colors(n=len, alpha=0.7)
dev.new()

if(order==TRUE){
ordenar(datos=datis, Factor=Factor[zz], var=var, dec=dec)

if(dec=="."){
selvar<-read.csv("selvar.csv", dec=dec)
}
else{
selvar<-read.csv2("selvar.csv",dec=dec)
}

selvar<-selvar[order(selvar[,2]),]

var1<-as.character(unique(selvar[,4]))

if(file.exists("selvar.csv")){
file.remove("selvar.csv")
}
}
else{
var1<-var
}


PC(data = datis , variables = var1 , group = "NF" , ellipse=ellipse, convex = convex, COLOR=COLOR, PCH=PCH, dec=dec, cor=cor)
mtext(text = text , line = 1 , cex = 2 , font = 2)
}
}
}
}

if(lenF>2){
g<-0
for(zz in 1:lenF){
if(zz<lenF){
for(tt in (zz+1):lenF){
if(g>0){
NF<-paste("NF",datos[,Factor[tt]], sep="-")
text<-paste(text, Factor[tt], sep="-")
}
else{
NF<-paste(datos[,Factor[zz]],datos[,Factor[tt]], sep="-")
NFA<-paste(Factor[zz], Factor[tt], sep="-")
text<-paste("Int. Plot:", NFA)
g<-1
}
}
}
}

datis<-data.frame(datos,NF)
len<-length(unique(as.character(datis[,"NF"])))
COLOR<-topo.colors(n=len, alpha=0.7)
dev.new()

if(order==TRUE){
ordenar(datos=datis, Factor=Factor[zz], var=var, dec=dec)

if(dec=="."){
selvar<-read.csv("selvar.csv", dec=dec)
}
else{
selvar<-read.csv2("selvar.csv",dec=dec)
}

selvar<-selvar[order(selvar[,2]),]

var1<-as.character(unique(selvar[,4]))

if(file.exists("selvar.csv")){
file.remove("selvar.csv")
}
}
else{
var1<-var
}


PC(data = datis , variables = var1 , group = "NF" , ellipse=ellipse, convex = convex, COLOR=COLOR, PCH=PCH, dec=dec, cor=cor)
mtext(text = text , line = 1 , cex = 2 , font = 2)

}


print(Resultados)


####Save the results
sink(file1)
print(Resultados)
sink()


if(file.exists("Polar coordinates.csv")){
file.remove("Polar coordinates.csv")
}


}


