\name{ZXI12}
\docType{data}
\alias{ZXI12}
\encoding{latin1}
\title{EXPOSURE TO ARSENIC AND MORTALITY FROM RESPIRATORY DISEASES-2}
\usage{data(ZXI12)}
\description{Dataset from a cohort study on arsenic exposure in  industry and deaths from respiratory diseases, available in the database Montana of the old package \emph{epicalc} (Chongsuvivatwong, 2012). These data are used to determine the predictive power of Poisson regression estimated in the example of the function \link{XI10}, because they were not used for the model estimation.}
\format{A data frame with 7 columns: number of deaths in each group (\emph{respdeath}), number of people per year of exposure (\emph{personyrs}), dividing the number of deaths and the number of people by years of exposure * 10,000 (\emph{respdeath.personyrs}), age groups (\emph{agegr}), period of employment (\emph{period}), commencement of employment (\emph{start}) and time of exposure to arsenic in years (\emph{arsenic}).}
\references{
Chongsuvivatwong, V. (2012) Epidemiological calculator. R package version 2.15.1.0.
}
\keyword{ZXI12}

 
