\name{ZXI6}
\docType{data}
\alias{ZXI6}
\encoding{latin1}
\title{PRIMARY PRODUCTION IN UPWELLING AREAS}
\usage{data(ZXI6)}
\description{Chlorophyll data, upwelling, stability, platform size, temperature and nutrients from different coastal areas of the world.}
\format{A data frame with 12 columns: upwelling area, latitude, longitude, chlorophyll concentration (\eqn{mg^{-3}}), percentage of continental shelf in the cell, Ekman transport (\eqn{m^3 km^{-1} s^{-1}}) which is a measure of upwelling, temperature, turbulence (\eqn{m^3 s^{-1}}), stability of the water column(\eqn{cycles s^{-1}}) and concentrations of phosphates, nitrates and silicates in \eqn{\mu M l^{-1}}.}
\references{
Patti, B., Guisande, C., Vergara, A.R., Riveiro, I., Maneiro, I., Barreiro, A., Bonanno, A., Buscaino, G., Cuttitta, A., Basilone, G. & Mazzola, S. (2008) Factors responsible for the differences in satellite-based chlorophyll a concentration between the major global upwelling areas. \emph{Estuarine, Coastal and Shelf Science}, 76, 775-786.
}
\keyword{ZXI6}

 
