\name{ZXII1}
\docType{data}
\alias{ZXII1}
\encoding{latin1}
\title{INFLUENCE OF MEDICAL ADVICE TO QUIT SMOKING}
\usage{data(ZXII1)}
\description{Data refer to a study by Silagy & Ketteridge (1997) on the effect of medical advice when quitting smoking. In the data file, the variable \emph{event.e} refers to the number of people who quit smoking by doctor's recommendation, \emph{n.e} the total number of people in the group to whom the doctor recommended to stop smoking and, \emph{event.c} and \emph{n.c} are the people who quit smoking and the number of people who were in the control group, to whom the doctor advised not to quit smoking, respectively.}
\format{A data frame with 5 columns: study, people who quit smoking by doctor's recommendation (\emph{event.e}), total number of people to whom the doctor recommended stop smoking(\emph{n.e}), total number of people who quit smoking in the control group(\emph{event.c}) and total number of people in the control group (\emph{n.c}). In the control group the doctor did not recommend anyone to stop smoking.}

\references{
Silagy, C. & Ketteridge, S. (1977) Physician advice for smoking cessation. In: Lancaster T, Silagy C, Fullerton D. Editores. Tobacco Addiction Module of the Cochrane Database of Systematic Reviews 4.
}
\keyword{ZXII1}

 
