IV3<-function(data, variables, group=NULL, alfa=0.05, IntervType="sd",
file="Output.csv", na="NA", dec=",", row.names=FALSE){


########################################################
# Seccin que realiza el procedimiento
########################################################

datos<-data

ic.var.ds<-function(x,alfa=0.05,tipo="sd",sup=TRUE){
  x<-x[!is.na(x)]
  if (length(x)>=2){
      n<-length(x)
      var1<-var(x, na.rm = TRUE)
      v<-ifelse(sup,(n-1)*var1/(qchisq(alfa/2,n-1)),(n-1)*var1/(qchisq(1-alfa/2,n-1)))
      v<-ifelse(toupper(tipo)=="SD",sqrt(v),v)
      return(v)
  }else return(NA)
 }

valores<-unlist(datos[,variables])
variables1<-factor(rep(variables,each=dim(datos)[1]))
agrupaciones<-data.frame(datos[rep(1:dim(datos)[1],length(variables)),group])
names(agrupaciones)<-group

datos2<-data.frame(agrupaciones,Variable=variables1,valor=valores)

group<-c(group,"Variable")
agrupa<-data.frame(datos2[,group])
if(length(group)==1) names(agrupa)<-group

if(toupper(IntervType)=="SD") var1<-as.data.frame.table(tapply(datos2$valor,as.list(agrupa),sd,na.rm=TRUE),responseName="SD") else
   var1<-as.data.frame.table(tapply(datos2$valor,as.list(agrupa),var,na.rm=TRUE),responseName="Variance") 
   
ICs1<-as.data.frame.table(tapply(datos2$valor,as.list(agrupa),ic.var.ds,alfa=alfa,tipo=IntervType),responseName="UpperLim")
ICs2<-as.data.frame.table(tapply(datos2$valor,as.list(agrupa),ic.var.ds,sup=FALSE,alfa=alfa,tipo=IntervType),responseName="LowerLim")

if(toupper(IntervType)=="SD") ICs<-na.omit(data.frame(ICs2,SD=var1[,"SD"],UpperLim=ICs1[,"UpperLim"])) else
   ICs<-na.omit(data.frame(ICs2,Variance=var1[,"Variance"],UpperLim=ICs1[,"UpperLim"]))

########################################################
# Seccin que muestra los resultados
########################################################

print(ICs)

if (!is.null(file)){

if(dec=="."){
write.csv(x=ICs,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = ICs,file = file, fileEncoding = "", row.names=row.names,na=na)
}
}
else{
}

}



