IX7<-function(data, varTime, Factor1, Covariable, Error, Factor2=NULL, Factor3=NULL,
SS=2, ResetPAR=TRUE, mfrow=NULL, YLAB="Dependent variable", 
XLAB="Time", graphT="Boxplot",
 PART=NULL,  LabelCatT=NULL, COLORT=NULL, BOXPLOTT=NULL,
BEANPLOTT=NULL, LEGENDT=NULL, AXIST=NULL, MTEXTT= NULL,
TEXTT=NULL, graph1="Boxplot",  PAR1=NULL,
OrderCat1=NULL, LabelCat1=NULL, COLOR1=NULL, BOXPLOT1=NULL,
BEANPLOT1=NULL, LEGEND1=NULL, AXIS1=NULL, MTEXT1= NULL,
TEXT1=NULL, graph2="Boxplot",  PAR2=NULL, OrderCat2=NULL, LabelCat2=NULL,
COLOR2=NULL, BOXPLOT2=NULL, BEANPLOT2=NULL, LEGEND2=NULL,
AXIS2=NULL, MTEXT2= NULL, TEXT2=NULL, graph3="Boxplot",  PAR3=NULL,
OrderCat3=NULL, LabelCat3=NULL, COLOR3=NULL, BOXPLOT3=NULL,
BEANPLOT3=NULL, LEGEND3=NULL, AXIS3=NULL, MTEXT3= NULL,
TEXT3=NULL, INTERPLOT1=NULL, INTERPLOT2=NULL, INTERPLOT3=NULL,
file="Output.txt"){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varTime), subset(datos, select=Error), subset(datos, select=Covariable),
subset(datos, select=Factor1))

if(!is.null(Factor2)){
datosT<-data.frame(datosT, subset(datos, select=Factor2))
}


if(!is.null(Factor3)){
datosT<-data.frame(datosT, subset(datos, select=Factor3))
}

datos<-na.exclude(datosT)

Covariable2<-NULL

if (missing(LabelCatT)) LabelCatT=varTime else LabelCatT=LabelCatT
if (missing(LabelCat1)) LabelCat1=OrderCat1 else LabelCat1=LabelCat1
if (missing(LabelCat2)) LabelCat2=OrderCat2 else LabelCat2=LabelCat2
if (missing(LabelCat3)) LabelCat3=OrderCat3 else LabelCat3=LabelCat3


Error<-Error
FF1<-Factor1
FF2<-Factor2
FF3<-Factor3

options(contrasts=c("contr.sum","contr.poly"))


datos1<-as.matrix(datos[,varTime])


datos2<-data.frame(datos[,Covariable],datos[,Factor1])
colnames(datos2)<-c(Covariable, Factor1)
fo<-paste("lm(datos1~",names(datos2)[1],"+",names(datos2)[2],",data=datos)")

#Modelo lineal
if(!is.null(Factor2)){
datos2<-data.frame(datos[,Covariable], datos[,Factor1],datos[,Factor2])
colnames(datos2)<-c(Covariable, Factor1,Factor2)
fo<-paste("lm(datos1~",names(datos2)[1],"+",names(datos2)[2],"*",names(datos2)[3],",data=datos)")
}


if(!is.null(Factor3)){
datos2<-data.frame(datos[,Covariable], datos[,Factor1],datos[,Factor2],datos[,Factor3])
colnames(datos2)<-c(Covariable, Factor1,Factor2, Factor3)
fo<-paste("lm(datos1~",names(datos2)[1],"+",names(datos2)[2],"*",names(datos2)[3],"*",names(datos2)[4],",data=datos)")
}



modelo<- lm(eval(parse(text=fo)))


#ANOVA

Factor <- factor(varTime)


resultado <- car::Anova(modelo, idata = data.frame(Factor), idesign = ~Factor, type=SS)
ANOVA<-summary(resultado, multivariate=FALSE)








num<-length(varTime)


d<-dim(datos1)
list<-d[1]

for (i in 1:(num-1)){
list<-append(list,d[1])
}

zz<-rep(varTime,list)

#Se convierte en una matrix de una columna
m<-matrix(datos1, ncol=1)

datos2<-data.frame(zz,m)

datos3<-as.matrix(datos[,c(Error,Factor1)])
ds<-as.matrix(datos[,c(Error,Factor1)])

if(!is.null(Covariable)){
datos3<-data.frame(datos[,c(Error,Factor1)], as.numeric(datos[,Covariable]))
ds<-data.frame(datos[,c(Error,Factor1)], as.numeric(datos[,Covariable]))

}
else{
}

if(!is.null(Covariable2)){
datos3<-data.frame(datos[,c(Error,Factor1)], as.numeric(datos[,Covariable]),as.numeric(datos[,Covariable2]))
ds<-data.frame(datos[,c(Error,Factor1)], as.numeric(datos[,Covariable]),as.numeric(datos[,Covariable2]))
}
else{
}



if(!is.null(Factor2)){
datos3<-as.matrix(datos[,c(Error,Factor1,Factor2)])
ds<-as.matrix(datos[,c(Error,Factor1,Factor2)])

if(!is.null(Covariable)){
datos3<-data.frame(datos[,c(Error,Factor1,Factor2)], as.numeric(datos[,Covariable]))
ds<-data.frame(datos[,c(Error,Factor1,Factor2)], as.numeric(datos[,Covariable]))
}
else{
}

if(!is.null(Covariable2)){
datos3<-data.frame(datos[,c(Error,Factor1,Factor2)], as.numeric(datos[,Covariable]),as.numeric(datos[,Covariable2]))
ds<-data.frame(datos[,c(Error,Factor1,Factor2)], as.numeric(datos[,Covariable]),as.numeric(datos[,Covariable2]))
}
else{
}

}
else{
}

if(!is.null(Factor3)){
datos3<-as.matrix(datos[,c(Error,Factor1,Factor2, Factor3)])
ds<-as.matrix(datos[,c(Error,Factor1,Factor2,Factor3)])

if(!is.null(Covariable)){
datos3<-data.frame(datos[,c(Error,Factor1,Factor2,Factor3)], as.numeric(datos[,Covariable]))
ds<-data.frame(datos[,c(Error,Factor1,Factor2,Factor3)], as.numeric(datos[,Covariable]))
}
else{
}

if(!is.null(Covariable2)){
datos3<-data.frame(datos[,c(Error,Factor1,Factor2,Factor3)], as.numeric(datos[,Covariable]),as.numeric(datos[,Covariable2]))
ds<-data.frame(datos[,c(Error,Factor1,Factor2,Factor3)], as.numeric(datos[,Covariable]),as.numeric(datos[,Covariable2]))
}
else{
}
}
else{
}



for (i in 1:(num-1)){
ds<-rbind(ds,datos3)
}


datos4<-data.frame(ds,datos2[,1],as.numeric(datos2[,2]))

colnames(datos4)<-c(Error,Factor1,"Time","varDep")

if(!is.null(Covariable)){
colnames(datos4)<-c(Error,Factor1,Covariable, "Time","varDep")
}
else{
}

if(!is.null(Covariable2)){
colnames(datos4)<-c(Error,Factor1,Covariable, Covariable2, "Time","varDep")
}
else{
}

if(!is.null(Factor2)){
colnames(datos4)<-c(Error,Factor1,Factor2, "Time","varDep")

if(!is.null(Covariable)){
colnames(datos4)<-c(Error,Factor1,Factor2,Covariable, "Time","varDep")
}
else{
}

if(!is.null(Covariable2)){
colnames(datos4)<-c(Error,Factor1,Factor2,Covariable, Covariable2, "Time","varDep")
}
else{
}

}
else{
}

if(!is.null(Factor3)){
colnames(datos4)<-c(Error,Factor1,Factor2, Factor3, "Time","varDep")
if(!is.null(Covariable)){
colnames(datos4)<-c(Error,Factor1,Factor2, Factor3,Covariable, "Time","varDep")
}
else{
}

if(!is.null(Covariable2)){
colnames(datos4)<-c(Error,Factor1,Factor2, Factor3,Covariable, Covariable2, "Time","varDep")
}
else{
}

}
else{
}

dim4<-dim(datos4)


facti<-0
if(!is.null(Factor2)) facti<-1 else ssff<-1
if(!is.null(Factor3)) facti<-2 else ssff<-1
covi<-1
if(!is.null(Covariable2)) covi<-2 else ssff<-1




varDep<-"varDep"


###############################################
#Seccion que muestra los resultados
###############################################


Resultados<-list("ANCOVA with repeated and without repeated measures", ANOVA)


print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(mfrow)){
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
par(mfrow=mfrow)
}
else{
devi<-as.numeric(length(dev.list()))
if(devi<=1) asss<-1 else dev.new()
}

if(!is.null(graphT)){

if(!is.null(COLORT)){
color<-COLORT
color1<-as.list(COLORT)
}
else{
color<-terrain.colors(length(unique(datos2[,1])))
color1<-as.list(color)
}

if(!is.null(LabelCatT)) datos2[,1]<-factor(datos2[,1], levels = varTime, labels = LabelCatT) else datos2[,1]<-factor(datos2[,1], levels = varTime, labels = varTime)


if(!is.null(PART)){
parexe<-paste("par(new,",toString(x=PART), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graphT=="Boxplot"){



if(!is.null(BOXPLOTT)){
boxplotexe<-paste("boxplot(","datos2[,2]~datos2[,1],",toString(x=BOXPLOTT), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos2[,2]~datos2[,1],",
"ylab=YLAB,", "xlab=XLAB,","col=color,",
"main='Factor Time',","cex.main=2",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOTT)){
beanplotexe<-paste("beanplot::beanplot(","datos2[,2]~datos2[,1],",toString(x=BEANPLOTT), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos2[,2]~datos2[,1],",
"ylab=YLAB,", "xlab=XLAB,","col=color1,",
"main='Factor Time',","cex.main=2",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGENDT)){
legendexe<-paste("legend(",toString(x=LEGENDT), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIST)){
axisexe<-paste("axis(",toString(x=AXIST), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXTT)){
mtextexe<-paste("mtext(",toString(x=MTEXTT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXTT)){
textexe<-paste("text(",toString(x=TEXTT), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph tiempo
else{
}






if(!is.null(graph1)){



if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()

if(!is.null(COLOR1)){
color<-COLOR1
color1<-as.list(COLOR1)
}
else{
color<-terrain.colors(length(unique(datos4[,FF1])))
color1<-as.list(color)
}

datos4[,FF1]<-factor(datos4[,FF1], levels = unique(datos4[,FF1]), labels = unique(datos4[,FF1]))

if(!is.null(OrderCat1)){
datos4[,FF1]<-factor(datos4[,FF1], levels = OrderCat1, labels = LabelCat1)
}
else{
if(!is.null(LabelCat1)) datos4[,FF1]<-factor(datos4[,FF1], levels = unique(datos4[,FF1]), labels = LabelCat1) else datos4<-datos4
}

if(!is.null(PAR1)){
parexe<-paste("par(new,",toString(x=PAR1), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph1=="Boxplot"){



if(!is.null(BOXPLOT1)){
boxplotexe<-paste("boxplot(","datos4[,varDep]~datos4[,Factor1],",toString(x=BOXPLOT1), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos4[,varDep]~datos4[,Factor1],",
"ylab=YLAB,", "xlab=FF1,", "col=color,",
"main=paste('Factor',Factor1),","cex.main=2",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT1)){
beanplotexe<-paste("beanplot::beanplot(","datos4[,varDep]~datos4[,Factor1],",toString(x=BEANPLOT1), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos4[,varDep]~datos4[,Factor1],",
"ylab=YLAB,","xlab=FF1,","col=color1,",
"main=paste('Factor',Factor1),","cex.main=2",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND1)){
legendexe<-paste("legend(",toString(x=LEGEND1), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS1)){
axisexe<-paste("axis(",toString(x=AXIS1), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT1)){
mtextexe<-paste("mtext(",toString(x=MTEXT1), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT1)){
textexe<-paste("text(",toString(x=TEXT1), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph  1
else{
}


if(!is.null(FF2)){

if(!is.null(graph2)){


if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()

if(!is.null(COLOR2)){
color<-COLOR2
color1<-as.list(COLOR2)
}
else{
color<-terrain.colors(length(unique(datos4[,FF2])))
color1<-as.list(color)
}

datos4[,FF2]<-factor(datos4[,FF2], levels = unique(datos4[,FF2]), labels = unique(datos4[,FF2]))

if(!is.null(OrderCat2)){
datos4[,FF2]<-factor(datos4[,FF2], levels = OrderCat2, labels = LabelCat2)
}
else{
if(!is.null(LabelCat2)) datos4[,FF2]<-factor(datos4[,FF2], levels = unique(datos4[,FF2]), labels = LabelCat2) else datos4<-datos4
}

if(!is.null(PAR2)){
parexe<-paste("par(new,",toString(x=PAR2), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph1=="Boxplot"){


if(!is.null(BOXPLOT2)){
boxplotexe<-paste("boxplot(","datos4[,varDep]~datos4[,Factor2],",toString(x=BOXPLOT2), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos4[,varDep]~datos4[,Factor2],",
"ylab=YLAB,", "xlab=FF2,", "col=color,",
"main=paste('Factor',Factor2),","cex.main=2",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT2)){
beanplotexe<-paste("beanplot::beanplot(","datos4[,varDep]~datos4[,Factor2],",toString(x=BEANPLOT2), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos4[,varDep]~datos4[,Factor2],",
"ylab=YLAB,","xlab=FF2,","col=color1,",
"main=paste('Factor',Factor2),","cex.main=2",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND2)){
legendexe<-paste("legend(",toString(x=LEGEND2), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS2)){
axisexe<-paste("axis(",toString(x=AXIS2), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT2)){
mtextexe<-paste("mtext(",toString(x=MTEXT2), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT2)){
textexe<-paste("text(",toString(x=TEXT2), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 2
else{
}
}
else{
}


if(!is.null(FF3)){
if(!is.null(graph3)){


if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()

if(!is.null(COLOR3)){
color<-COLOR3
color1<-as.list(COLOR3)
}
else{
color<-terrain.colors(length(unique(datos4[,FF3])))
color1<-as.list(color)
}

datos4[,FF3]<-factor(datos4[,FF3], levels = unique(datos4[,FF3]), labels = unique(datos4[,FF3]))

if(!is.null(OrderCat2)){
datos4[,FF3]<-factor(datos4[,FF3], levels = OrderCat3, labels = LabelCat3)
}
else{
if(!is.null(LabelCat3)) datos4[,FF3]<-factor(datos4[,FF3], levels = unique(datos4[,FF3]), labels = LabelCat3) else datos4<-datos4
}

if(!is.null(PAR3)){
parexe<-paste("par(new,",toString(x=PAR3), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(graph1=="Boxplot"){


if(!is.null(BOXPLOT3)){
boxplotexe<-paste("boxplot(","datos4[,varDep]~datos4[,Factor3],",toString(x=BOXPLOT3), ")")
eval(parse(text=boxplotexe))
}
else{
boxplotexe<-paste("boxplot(","datos4[,varDep]~datos4[,Factor3],",
"ylab=YLAB,", "xlab=FF3,", "col=color,",
"main=paste('Factor',Factor3),","cex.main=2",")")
eval(parse(text=boxplotexe))
}

}#Final boxplot y comienzo Beanplot
else{


if(!is.null(BEANPLOT3)){
beanplotexe<-paste("beanplot::beanplot(","datos4[,varDep]~datos4[,Factor3],",toString(x=BEANPLOT3), ")")
eval(parse(text=beanplotexe))
}
else{
beanplotexe<-paste("beanplot::beanplot(","datos4[,varDep]~datos4[,Factor3],",
"ylab=YLAB,","xlab=FF3,","col=color1,",
"main=paste('Factor',Factor3),","cex.main=2",")")
eval(parse(text=beanplotexe))
}


}


if(!is.null(LEGEND3)){
legendexe<-paste("legend(",toString(x=LEGEND3), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS3)){
axisexe<-paste("axis(",toString(x=AXIS3), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT3)){
mtextexe<-paste("mtext(",toString(x=MTEXT3), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT3)){
textexe<-paste("text(",toString(x=TEXT3), ")")
eval(parse(text=textexe))
}
else{
}



}#Final graph 3
else{
}
}
else{
}

#Graficos de interaccion

#Factor1

if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()
if(!is.null(LabelCatT)) datos4[,(dim4[2]-1)]<-factor(datos4[,(dim4[2]-1)], levels = varTime, labels = LabelCatT) else datos4[,(dim4[2]-1)]<-factor(datos4[,(dim4[2]-1)], levels = varTime, labels = varTime)

if(!is.null(INTERPLOT1)){
interactionexe<-paste("interaction.plot(datos4[,(dim4[2]-1)],datos4[,Factor1], datos4[,varDep],",toString(x=INTERPLOT1), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos4[,(dim4[2]-1)],datos4[,Factor1], datos4[,varDep],",
"ylab=YLAB,", "xlab=XLAB,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,",
"main=paste('Factor',Factor1),","cex.main=2,","col=rainbow(length(unique(datos4[,Factor1]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}


#Factor2

if(!is.null(Factor2)){
if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()

if(!is.null(INTERPLOT2)){
interactionexe<-paste("interaction.plot(datos4[,(dim4[2]-1)],datos4[,Factor2], datos4[,varDep],",toString(x=INTERPLOT2), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos4[,(dim4[2]-1)],datos4[,Factor2], datos4[,varDep],",
"ylab=YLAB,", "xlab=XLAB,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,",
"main=paste('Factor',Factor2),","cex.main=2,","col=rainbow(length(unique(datos4[,Factor2]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}

}
else{
}

#Factor2

if(!is.null(Factor3)){
if(!is.null(mfrow)) dfssdfdfs<-1 else dev.new()

if(!is.null(INTERPLOT3)){
interactionexe<-paste("interaction.plot(datos4[,(dim4[2]-1)],datos4[,Factor3], datos4[,varDep],",toString(x=INTERPLOT3), ")")
eval(parse(text=interactionexe))
}
else{
intexe<-paste("interaction.plot(datos4[,(dim4[2]-1)],datos4[,Factor3], datos4[,varDep],",
"ylab=YLAB,", "xlab=XLAB,", "legend=TRUE,", "font.lab=2,", "cex.lab=1.5,",
"main=paste('Factor',Factor3),","cex.main=2,","col=rainbow(length(unique(datos4[,Factor3]))),",
"trace.label=''", ")")
eval(parse(text=intexe))
}

}
else{
}



}
