XI3<-function(data, variables, method= "vifstep", threshold=10, varCode=NULL, 
 file1="VIF.csv",  file2="Variables.csv", na="NA", dec=",", row.names=FALSE){


###############################################
#Seccin que realiza el procedimiento
###############################################

datos<-data

datos1<-na.exclude(subset(datos,selec=variables))


#Colinearity
if(method=="vif"){
write.csv2(datos1,"VIF_variables.csv",row.names=FALSE)
write.table(threshold,"threshold.txt", row.names=FALSE,col.names=FALSE)
write.table(threshold,"VIF.txt", row.names=FALSE,col.names=FALSE)
while(file.exists("VIF_Created.txt") ==FALSE){
}
file.remove("VIF_Created.txt")
if(file.exists("VIF.txt") ) {file.remove("VIF.txt")}
VIF<-read.csv2(file = "VIF_Result.csv", header=TRUE, encoding="latin1")
}

if(method=="vifcor"){
VIF<-usdm::vifcor(datos1)
VIF<-attributes(VIF)
VIF<-VIF$results
}

if(method=="vifstep"){
VIF<-usdm::vifstep(datos1, th=threshold)
VIF<-attributes(VIF)
VIF<-VIF$results
}



###############################################
#Seccin que muestra los resultados
###############################################



print(VIF)



if(dec=="."){
write.csv(x=VIF,file = file1, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = VIF,file= file1, fileEncoding = "", row.names=row.names,na=na)
}

datos3<-subset(datos, select=as.character(unique(VIF[,1])))

if(!is.null(varCode)){
datos2<-subset(datos, select=varCode)
datos3<-data.frame(datos2,datos3)
}

if(dec=="."){
write.csv(x=datos3,file= file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = datos3,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(file.exists("threshold.txt")){
file.remove("threshold.txt")
}

if(file.exists("VIF_Created.txt")){
file.remove("VIF_Created.txt")
}


}