XI7<-function(data, cat, resp, model="Model.rda",
 file="Model predictions.csv", na="NA", dec=",", row.names=FALSE){



########################################################
# Seccin que realiza el procedimiento
########################################################

ModelB<-NULL


datos<-na.exclude(data)


#La otra clase
vector<-datos[,cat]
vector<-vector[!vector == resp] 
cod<-as.character(unique(vector))

if(length(cod)==1) cod<-cod else cod<-"Other category"

load(file=model)


prob<-(predict(ModelB, type="response", newdata=datos))

prob2<-data.frame(datos,prob,prob)

colnames(prob2)<-c(colnames(datos),"Probability","Predictions")

dimty<-dim(prob2)

for(i in 1:dimty[1]){
if(prob2[i,"Probability"]>0.4999){
prob2[i, "Predictions"]<-as.character(resp)
}
else{
prob2[i, "Predictions"]<-cod
}
}


acierto<-sum(as.character(prob2[,cat])==as.character(prob2[,"Predictions"]))/ dim(prob2)[1]*100
Resultados<-list("PERCENTAGE OF CASES CORRECTLY IDENTIFIED",acierto)
print(Resultados)

if(dec=="."){
write.csv(x=prob2 ,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = prob2 ,file = file, fileEncoding = "", row.names=row.names,na=na)
}


}
