XI8<-function(data, cat, var, optimize=TRUE, methop="cart", stepwise=FALSE, order=TRUE,
cart=TRUE, minsplit=2, minbucket=2, cp=0.0001, surrogatestyle=0,
type=0, extra=2, varlen=0, ycompress= TRUE, main=NULL, cex.main=2, cex=1.2,
file1="Predictions.csv", file2="Coefficients.csv", file3="Table.csv",
na="NA", dec=",", row.names=FALSE, model= "Model.rda", file="Output.txt"){



########################################################
# Seccin que realiza el procedimiento
########################################################

datos<-na.exclude(data)


datosT<-data.frame(subset(datos, select=cat), subset(datos, select=var))
datos<-na.exclude(datosT)


if(optimize==TRUE & methop=="stepwise"){
stepwise= TRUE
}


Datos2 <- factor(datos[,cat], exclude=NULL)


leng<-length(var)
fo<-var[1]
for(i in 2:leng){
fo<-paste(fo,var[i],sep="+")
}
formula<-as.formula(paste(cat,"~",fo))


leng<-length(var)
fo<-var[1]
for(i in 2:leng){
clase<-class(datos[,var[i]])
if(clase=="factor"){
if(optimize==TRUE){
}
else{
fo<-paste(fo,var[i],sep="+")
}

}
else{
fo<-paste(fo,var[i],sep="+")
}
}
formula1<-as.formula(paste(cat,"~",fo))






ZZ<-matrix(c("","","","","","","",""), nrow=4)



begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-"Logistic regression...."
ZZ[3,1]<-begin.times
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)

MLM.1 <- nnet::multinom(formula, data=datos, trace=FALSE, MaxNWts=50000)
Res1<-summary(MLM.1, cor=FALSE, Wald=TRUE)
acierto1<-sum(predict(MLM.1)==Datos2)/ dim(datos)[1]*100
Model1<-MLM.1
save(Model1,file=model)

pred1 <- data.frame(datos[, cat],predict(MLM.1))
names(pred1)<-c("Real", "Logistic model")

coef1<-as.data.frame(coefficients(MLM.1))
coef2<-data.frame(Classes=rownames(coef1), coef1)

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(order==FALSE){
if(dec=="."){
coef2<-read.csv(file = file2)
}
else{
coef2<-read.csv2(file=file2)
}


coef2<-coef2[order(coef2[,1], decreasing=TRUE), ]

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}#end order

tabla1 <- table(predict(MLM.1),Datos2)
tporc1 <- prop.table(tabla1,2)*100


Res2<-""
acierto2<-""




if(stepwise==TRUE){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-"Stepwise logistic regression...."
ZZ[3,1]<-begin.times
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
MLM.2<-MASS::stepAIC(MLM.1)
Res2<-summary(MLM.2, cor=FALSE, Wald=TRUE)
acierto2<- sum(predict(MLM.2)==Datos2)/ dim(datos)[1]*100
pred2<- data.frame(pred1,predict(MLM.2))
names(pred2)<-c("Real",  "Logistic model", "Stepwise model")
coef3<-as.data.frame(coefficients(MLM.2))
coef4<-data.frame(Classes=rownames(coef3), coef3)

tabla2 <- table(predict(MLM.2),Datos2)
tporc2 <- prop.table(tabla2,2)*100

Model2<-MLM.2
save(Model2,file=model)

if(dec=="."){
write.csv(x=coef4,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef4,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(dec=="."){
write.csv(x=tporc2 ,file = file3, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = tporc2 ,file = file3, fileEncoding = "", row.names=row.names,na=na)
}


if(order==FALSE){
if(dec=="."){
coef4<-read.csv(file = file2)
}
else{
coef4<-read.csv2(file=file2)
}


coef4<-coef4[order(coef4[,1], decreasing=TRUE), ]

if(dec=="."){
write.csv(x=coef4,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef4,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}#end order


}#End Stepwise Logistic regression



Res3<-""
acierto3<-""

if(optimize==TRUE){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-"Optimize logistic regression...."
ZZ[3,1]<-begin.times
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)

MLM.1 <- nnet::multinom(formula1, data=datos, trace=FALSE, MaxNWts=50000)
MLM.2<-MASS::stepAIC(MLM.1)
coef3<-as.data.frame(coefficients(MLM.2))



if(methop=="stepwise"){
acierto3<-acierto2

predF<-data.frame(pred2,predict(MLM.2))
names(predF)<-c("Real",  "Logistic model", "Stepwise model","Optimize model")

aciertobase<-acierto2
coef<-names(coef3[-1])
lenc<-length(coef)
fo<-coef[1]
for(i in 2:lenc){
fo<-paste(fo,coef[i],sep="+")
}

foR<-fo



for(i in 1:leng){
if(aciertobase<100){
pat<-paste(var[i],"+", sep="")
sad<-regexpr(pattern = pat , text = fo , fixed = TRUE) > 0 
if(sum(sad)==0){

fo<-paste(fo,var[i],sep="+")
formula<-as.formula(paste(cat,"~",fo))
MLM.3 <- nnet::multinom(formula, data=datos, trace=FALSE, MaxNWts=50000)
Res3<-summary(MLM.3, cor=FALSE, Wald=TRUE)
acie<-sum(predict(MLM.3)==Datos2)/ dim(datos)[1]*100


if(acie>aciertobase){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-begin.times
ZZ[3,1]<-fo
ZZ[4,1]<-paste("Cases correctly identified", round(acie,digits=2),"%")
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
aciertobase<-acie
acierto3<-acie
foR<-fo

Model3<-MLM.3
save(Model3,file=model)

predF<- data.frame(pred2,predict(MLM.3))
names(predF)<-c("Real",  "Logistic model", "Stepwise model","Optimize model")

coef1<-as.data.frame(coefficients(MLM.3))
coef2<-data.frame(Classes=rownames(coef1), coef1)

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(order==FALSE){
if(dec=="."){
coef2<-read.csv(file = file2)
}
else{
coef2<-read.csv2(file=file2)
}


coef2<-coef2[order(coef2[,1], decreasing=TRUE), ]

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}#end order

tabla1 <- table(predict(MLM.3),Datos2)
tporc1 <- prop.table(tabla1,2)*100


}
else{
fo<-foR
}

}#end sad
}
}


if(acierto3<100){
aciertobase<-acierto3


foR<-fo

for(i in 1:leng){
if(aciertobase<100){
pat<-paste(var[i],"+", sep="")
sad<-regexpr(pattern = pat , text = fo , fixed = TRUE) > 0 
if(sum(sad)==0){
fo<-paste(fo,var[i],sep="+")
formula<-as.formula(paste(cat,"~",fo))
MLM.3 <- nnet::multinom(formula, data=datos, trace=FALSE, MaxNWts=50000)
Res3<-summary(MLM.3, cor=FALSE, Wald=TRUE)
acie<-sum(predict(MLM.3)==Datos2)/ dim(datos)[1]*100


if(acie>aciertobase){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-begin.times
ZZ[3,1]<-fo
ZZ[4,1]<-paste("Cases correctly identified", round(acie,digits=2),"%")
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
aciertobase<-acie
acierto3<-acie
foR<-fo

Model3<-MLM.3
save(Model3,file=model)

predF<- data.frame(pred2,predict(MLM.3))
names(predF)<-c("Real",  "Logistic model", "Stepwise model","Optimize model")

coef1<-as.data.frame(coefficients(MLM.3))
coef2<-data.frame(Classes=rownames(coef1), coef1)

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(order==FALSE){
if(dec=="."){
coef2<-read.csv(file = file2)
}
else{
coef2<-read.csv2(file=file2)
}


coef2<-coef2[order(coef2[,1], decreasing=TRUE), ]

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}#end order

tabla1 <- table(predict(MLM.3),Datos2)
tporc1 <- prop.table(tabla1,2)*100


}
else{
fo<-foR
}
}
}#end sad
}
}


if(acierto3<100){
aciertobase<-acierto3

foR<-fo

for(i in 1:leng){
if(aciertobase<100){
pat<-paste(var[i],"+", sep="")
sad<-regexpr(pattern = pat , text = fo , fixed = TRUE) > 0 
if(sum(sad)==0){
fo<-paste(fo,var[i],sep="+")
formula<-as.formula(paste(cat,"~",fo))
MLM.3 <- nnet::multinom(formula, data=datos, trace=FALSE, MaxNWts=50000)
Res3<-summary(MLM.3, cor=FALSE, Wald=TRUE)
acie<-sum(predict(MLM.3)==Datos2)/ dim(datos)[1]*100


if(acie>aciertobase){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-begin.times
ZZ[3,1]<-fo
ZZ[4,1]<-paste("Cases correctly identified", round(acie,digits=2),"%")
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
aciertobase<-acie
acierto3<-acie
foR<-fo

Model3<-MLM.3
save(Model3,file=model)

predF<- data.frame(pred2,predict(MLM.3))
names(predF)<-c("Real",  "Logistic model", "Stepwise model","Optimize model")

coef1<-as.data.frame(coefficients(MLM.3))
coef2<-data.frame(Classes=rownames(coef1), coef1)

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(order==FALSE){
if(dec=="."){
coef2<-read.csv(file = file2)
}
else{
coef2<-read.csv2(file=file2)
}


coef2<-coef2[order(coef2[,1], decreasing=TRUE), ]

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}#end order

tabla1 <- table(predict(MLM.3),Datos2)
tporc1 <- prop.table(tabla1,2)*100


}
else{
fo<-foR
}
}
}#end sad
}
}

}#end method stepwise



if(methop=="cart"){



leng<-length(var)
fo<-var[1]
for(i in 2:leng){
fo<-paste(fo,var[i],sep="+")
}
formula<-as.formula(paste(cat,"~",fo))

cartT<-rpart::rpart(formula, data=datos)
lencart<-length(cartT$variable.importance)

fo<-names(cartT$variable.importance)[1]
aciertobase<-0

for(i in 2:lencart){
if(aciertobase<100){
fo<-paste(fo,names(cartT$variable.importance)[i],sep="+")
formula<-as.formula(paste(cat,"~",fo))
MLM.3 <- nnet::multinom(formula, data=datos, trace=FALSE, MaxNWts=50000)
Res3<-summary(MLM.3, cor=FALSE, Wald=TRUE)
acie<-sum(predict(MLM.3)==Datos2)/ dim(datos)[1]*100


if(acie>(aciertobase+aciertobase*10/100)){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-begin.times
ZZ[3,1]<-fo
ZZ[4,1]<-paste("Cases correctly identified", round(acie,digits=2),"%")
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
aciertobase<-acie
acierto3<-acie
foR<-fo

Model3<-MLM.3
save(Model3,file=model)

predF<- data.frame(pred1,predict(MLM.3))
names(predF)<-c("Real",  "Logistic model", "Optimize model")

coef1<-as.data.frame(coefficients(MLM.3))
coef2<-data.frame(Classes=rownames(coef1), coef1)

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(order==FALSE){
if(dec=="."){
coef2<-read.csv(file = file2)
}
else{
coef2<-read.csv2(file=file2)
}


coef2<-coef2[order(coef2[,1], decreasing=TRUE), ]

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}#end order

tabla1 <- table(predict(MLM.3),Datos2)
tporc1 <- prop.table(tabla1,2)*100


}
else{
fo<-foR
}
}
}



#Second round
if(acierto3<100){
aciertobase<-acierto3




foR<-fo

for(i in 2:lencart){
if(aciertobase<100){
pat<-paste(names(cartT$variable.importance)[i],"+", sep="")
sad<-regexpr(pattern = pat , text = fo , fixed = TRUE) > 0 
if(sum(sad)==0){
fo<-paste(fo,names(cartT$variable.importance)[i],sep="+")
formula<-as.formula(paste(cat,"~",fo))
MLM.3 <- nnet::multinom(formula, data=datos, trace=FALSE, MaxNWts=50000)
Res3<-summary(MLM.3, cor=FALSE, Wald=TRUE)
acie<-sum(predict(MLM.3)==Datos2)/ dim(datos)[1]*100


if(acie>aciertobase){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-begin.times
ZZ[3,1]<-fo
ZZ[4,1]<-paste("Cases correctly identified2", round(acie,digits=2),"%")
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
aciertobase<-acie
acierto3<-acie
foR<-fo

Model3<-MLM.3
save(Model3,file=model)

predF<- data.frame(pred1,predict(MLM.3))
names(predF)<-c("Real",  "Logistic model", "Optimize model")

coef1<-as.data.frame(coefficients(MLM.3))
coef2<-data.frame(Classes=rownames(coef1), coef1)

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(order==FALSE){
if(dec=="."){
coef2<-read.csv(file = file2)
}
else{
coef2<-read.csv2(file=file2)
}


coef2<-coef2[order(coef2[,1], decreasing=TRUE), ]

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}#end order

tabla1 <- table(predict(MLM.3),Datos2)
tporc1 <- prop.table(tabla1,2)*100


}
else{
fo<-foR
}
}
}
}


#Third round
if(acierto3<100){
aciertobase<-acierto3

foR<-fo

for(i in 2:lencart){
if(aciertobase<100){
pat<-paste(names(cartT$variable.importance)[i],"+", sep="")
sad<-regexpr(pattern = pat , text = fo , fixed = TRUE) > 0 
if(sum(sad)==0){
fo<-paste(fo,names(cartT$variable.importance)[i],sep="+")
formula<-as.formula(paste(cat,"~",fo))
MLM.3 <- nnet::multinom(formula, data=datos, trace=FALSE, MaxNWts=50000)
Res3<-summary(MLM.3, cor=FALSE, Wald=TRUE)
acie<-sum(predict(MLM.3)==Datos2)/ dim(datos)[1]*100


if(acie>aciertobase){
begin.time<-Sys.time() 
begin.times <- format(begin.time, "%b %d, %Y at %X") 
ZZ[2,1]<-begin.times
ZZ[3,1]<-fo
ZZ[4,1]<-paste("Cases correctly identified3", round(acie,digits=2),"%")
write.table(ZZ,"Inf.txt", row.names=FALSE,col.names=FALSE)
aciertobase<-acie
acierto3<-acie
foR<-fo

Model3<-MLM.3
save(Model3,file=model)

predF<- data.frame(pred1,predict(MLM.3))
names(predF)<-c("Real",  "Logistic model", "Optimize model")

coef1<-as.data.frame(coefficients(MLM.3))
coef2<-data.frame(Classes=rownames(coef1), coef1)

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}

if(order==FALSE){
if(dec=="."){
coef2<-read.csv(file = file2)
}
else{
coef2<-read.csv2(file=file2)
}


coef2<-coef2[order(coef2[,1], decreasing=TRUE), ]

if(dec=="."){
write.csv(x=coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = coef2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
}#end order

tabla1 <- table(predict(MLM.3),Datos2)
tporc1 <- prop.table(tabla1,2)*100


}
else{
fo<-foR
}
}
}
}



}

}

}#end method cart


}#end optimize






if(cart==TRUE){
CART<- rpart::rpart(formula,method="class",control=rpart::rpart.control(minsplit=minsplit, minbucket =minbucket,
cp = cp, surrogatestyle = surrogatestyle), data=datos)

rpart.plot::rpart.plot(CART,type=type, extra=extra, varlen=varlen, ycompress=ycompress, main=main, cex.main=cex.main,cex=cex)
}

pred<-pred1
if(stepwise==TRUE) pred<-pred2 else pred<-pred
if(optimize==TRUE) pred<-predF else pred<-pred


if(dec=="."){
write.csv(x=pred,file = file1, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = pred,file = file1, fileEncoding = "", row.names=row.names,na=na)
}



if(dec=="."){
write.csv(x=tporc1 ,file = file3, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = tporc1 ,file = file3, fileEncoding = "", row.names=row.names,na=na)
}

Resultados<-list("LOGISTIC REGRESSION", Res1, "STEPWISE LOGISTIC REGRESSION", Res2,
"OPTIMIZE LOGISTIC REGRESSION", Res3, "PERCENTAGE OF CASES CORRECTLY IDENTIFIED-Logistic regression",
acierto1, "PERCENTAGE OF CASES CORRECTLY IDENTIFIED-Stepwise logistic regression", acierto2,
"PERCENTAGE OF CASES CORRECTLY IDENTIFIED-Optimize logistic regression", acierto3)

print(Resultados)


if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}

}
