XIII1<-function(data,  var, cat=NULL, plot3d=TRUE, ResetPAR=TRUE, PAR=NULL,  xlim=NULL, ylim=NULL,
main=NULL, cex.main=1.7, font.main=2, dim1 = c(1,2), dim2 = c(1,2,3), map = "symmetric",
what = c("all", "all"), mass = c("FALSE", "FALSE"), contrib = c("none", "none"),
col = c("#0000FF", "#FF0000"), labcol=c("#0000FF", "#FF0000"), pch = c(16, 1, 17, 24),
labels = c(2, 2), arrows = c("FALSE", "FALSE"),  LEGEND=NULL, AXIS=NULL,
MTEXT= NULL, TEXT=NULL, file="Output.txt"){



########################################################
# Seccin que realiza el procedimiento
########################################################

datos<-data


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2))
}


datosT<-data.frame(subset(datos, select=var))

if(!is.null(cat)){
datosT<-data.frame(subset(datos, select=cat), datosT)
}


datos1<-na.exclude(datosT)


if(!is.null(cat)){
zz<-as.character(datos1[,cat])
datos2<-as.data.frame(datos1[,-1],row.names=zz)
corre<-ca::ca(datos2)
}
else{
corre<-ca::ca(datos1)
}

#Correspondencias


plot(x=corre, dim = dim1, map = map, what = what, mass = mass, contrib = contrib, col = col,
pch = pch, labels = labels, arrows = arrows, xlim=xlim, ylim=ylim, main=main, cex.main=cex.main,
font.main=font.main)

if(plot3d==TRUE){
ca::plot3d.ca(x=corre, dim = dim2, map = map, what = what, col = col, labcol = labcol, pch = pch,
labels = labels, arrows = arrows)
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



print(corre)

sum<-summary(corre)

print(sum)

if(!is.null(file)){
sink(file)
print(corre)
print(sum)
sink()
}

}
     

