XIV1<-function(data, cat, var, ResetPAR=TRUE, PAR=NULL,
CART=NULL, RPART=NULL, file="Output.txt"){



########################################################
# Seccin que realiza el procedimiento
########################################################


datos<-na.exclude(data)

datosT<-data.frame(subset(datos, select=cat), subset(datos, select=var))
datos<-na.exclude(datosT)

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}



Datos2 <- factor(datos[,cat], exclude=NULL)


leng<-length(var)
fo<-var[1]
for(i in 2:leng){
fo<-paste(fo,var[i],sep="+")
}
formula<-as.formula(paste(cat,"~",fo))


if(!is.null(CART)){
cartexe<-paste("rpart::rpart(","formula=formula,","data=datos,",toString(x=CART), ")")
CART<-eval(parse(text=cartexe))
}
else{
cartexe<-paste("rpart::rpart(","formula=formula,", "control=rpart::rpart.control(minsplit=2, minbucket=2, cp=0.01,
maxcompete = 4, maxsurrogate = 5, usesurrogate = 2, xval = 10, surrogatestyle=0, maxdepth = 30),", "data=datos",")")
CART<-eval(parse(text=cartexe))
}


if(!is.null(RPART)){
cartexe<-paste("rpart.plot::rpart.plot(","x=CART,",toString(x=RPART), ")")
eval(parse(text=cartexe))
}
else{
cartexe<-paste("rpart.plot::rpart.plot(","x=CART,", "type=0,", "extra=2,", "varlen=0,", " ycompress= TRUE,", " main=NULL,", " cex.main=2,", " cex=1.2",")")
print(cartexe)
eval(parse(text=cartexe))
}


Resultados<-list(CART)

print(Resultados)


if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}

}

