XIV5<-function(data, cat, var, ResetPAR=TRUE, PAR=NULL,
HEATMAP=NULL, mean=TRUE, LEGEND=NULL, AXIS=NULL, MTEXT= NULL,
TEXT=NULL){



###############################################
#Seccin que realiza el procedimiento
###############################################
datos<-data

datosT<-data.frame(subset(datos, select=cat), subset(datos, select=var))

datos<-na.exclude(datosT)

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2,cex.lab=1.5, cex.main=1.2)
}



if(mean==TRUE){
datos1<-aggregate(datos[,var],na.rm=TRUE,by=list(datos[,cat]),mean)
datos2<-as.matrix(datos1[,-1])
rownames(datos2)<-datos1[,1]
}
else{
datos1<-datos[,var]
datos2<-as.matrix(datos1)
rownames(datos2)<-datos[,cat]
}


if(!is.null(HEATMAP)){
heatmapexe<-paste("heatmap(","x=datos2,",toString(x=HEATMAP), ")")
eval(parse(text=heatmapexe))
}
else{
heatmapexe<-paste("heatmap(","x=datos2,", ")")
eval(parse(text=heatmapexe))
}




if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}

if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}




}
