XV2<-function(data, varY,  varX=NULL, frequency, start, ResetPAR=TRUE, PAR=NULL,  TS=NULL,
PLOTSERIE=NULL, SPECPGRAM=NULL, SPECAR=NULL, COHERENCE=NULL,
SPECTRUM=NULL, PLOTSPECTRUM=NULL, file="Output.txt"){



########################################################
# Seccin que realiza el procedimiento
########################################################



datos<-data

if(!is.null(varX)){
datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))
datos<-datosT
}
else{
datosT<-data.frame(subset(datos, select=varY))
datos<-datosT
}

if (missing(start)) start=1 else start=start
if (missing(frequency)) frequency=1 else frequency=frequency




if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}


if(!is.null(TS)){
tsexe<-paste("ts(","data=datos,","frequency=frequency,","start=start,",toString(x=TS), ")")
serie1<-eval(parse(text=tsexe))
}
else{
tsexe<-paste("ts(","data=datos,","frequency=frequency,","start=start",")")
serie1<-eval(parse(text=tsexe))
}

serie1 <-  na.exclude(zoo::na.approx(serie1))

devi<-as.numeric(length(dev.list()))

if(devi<=1) asss<-1 else dev.new()

if(!is.null(PLOTSERIE)){
plotexe<-paste("plot(","x=serie1,",toString(x=PLOTSERIE), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot(","x=serie1,","main=''",")")
eval(parse(text=plotexe))
}

dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}

if(!is.null(SPECPGRAM)){
plotexe<-paste("spec.pgram(","x=serie1[,1],",toString(x=SPECPGRAM), ")")
espectro1<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("spec.pgram(","x=serie1[,1],","main='Raw periodogram',",")")
espectro1<-eval(parse(text=plotexe))
}


dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}

if(!is.null(SPECAR)){
plotexe<-paste("spec.ar(","x=serie1[,1],",toString(x=SPECAR), ")")
espectro2<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("spec.ar(","x=serie1[,1],","main='Spectral density',",")")
espectro2<-eval(parse(text=plotexe))
}


valor1_1<-espectro1$spec
max1<-which.max(valor1_1)
valor2_1<-1/espectro1$freq

ciclo1<-valor2_1[max1]*frequency


valor1_2<-espectro2$spec
max2<-which.max(valor1_2)
valor2_2<-1/espectro2$freq

ciclo2<-valor2_2[max2]*frequency

coh<-""
lag<-""
if(!is.null(varX)){
dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}



if(!is.null(COHERENCE)){
plotexe<-paste("seewave::coh(","wave1=serie1[,1],", "wave2=serie1[,2]," ,toString(x=COHERENCE), ")")
coherencia<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("seewave::coh(","wave1=serie1[,1],", "wave2=serie1[,2]",")")
coherencia<-eval(parse(text=plotexe))
}

max<-which.max(coherencia[,2])

coh<-as.numeric(1/coherencia[max,1]/1000)


dev.new()

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}

if(!is.null(SPECTRUM)){
plotexe<-paste("spectrum(","x=serie1,",toString(x=SPECTRUM), ")")
espectro<-eval(parse(text=plotexe))
}
else{
plotexe<-paste("spectrum(","x=serie1",")")
espectro<-eval(parse(text=plotexe))
}


if(!is.null(PLOTSPECTRUM)){
plotexe<-paste("plot(","x=espectro,", "plot.type='phase',", toString(x=PLOTSPECTRUM), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot(","x=espectro,","plot.type='phase',","main='Phase spectrum'", ")")
eval(parse(text=plotexe))
}


lag<-espectro$phase[max]
}


Resultados<-list("SERIE", serie1, "CYCLE ESTIMATED USING RAW PERIODOGRAM", ciclo1,
"CYCLE ESTIMATED USING SPECTRAL DENSITY", ciclo2, "COHERENCE", coh, "LAG", lag)


print(Resultados)





if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}

}
