XV5<-function(data, var,  varRef=NULL, varCode=NULL, min=0, max=1, file="Standardized.csv", na="NA", dec=",", row.names=FALSE){

datos<-subset(data, select=var)


####Standardization
sta<-function(selection, zz, var,a, min, max){
datosE<-selection

for (z in 1:a[2]){
matrixE<-matrix(c(min, max, min(selection[,z],na.rm=TRUE),max(selection[,z],na.rm=TRUE)), nrow = 2 , ncol = 2)
reg<-lm(matrixE[,1]~matrixE[,2])
datosC<-reg$coefficients[1]+selection[,z]*reg$coefficients[2]
datosE<-cbind(datosE,datosC)
}

if(zz==1) datosE<-as.data.frame(datosE[,-1]) else datosE<-datosE[,-c(1:a[2])]
if(zz==1) colnames(datosE)<-var else colnames(datosE)<-colnames(selection)
return(datosE)
}
###End function standardization


###Standardized data
a<-dim(datos)

if(!is.null(varRef)){
selection<-datos/datos[,varRef]
}
else{
zz<-a[1]+1
selection<-sta(selection=datos,zz=zz,var=var, a=a, min=min, max=max)
}

if(!is.null(varCode)){
datos2<-subset(data, select=varCode)
datos<-data.frame(datos2,selection)
}
else{
datos<-selection
}

if(dec=="."){
write.csv(x=datos,file= file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = datos,file = file, fileEncoding = "", row.names=row.names,na=na)
}

}