XV7<-function(data, var, cat=NULL, varCode=NULL,  remove=FALSE, Nan=FALSE, quant1=0.05, quant2 = 0.95,   file="Outliers.csv",  na="NA", dec=",", row.names=FALSE){

datos<-subset(data, select=var)

len<-length(var)

remove_outliers <- function(x, na.rm = TRUE, ...) {
  qnt <- quantile(x, probs=c(quant1, quant2), na.rm = na.rm, ...)
  H <- 1.5 * IQR(x, na.rm = na.rm)
  y <- x
  y[x < (qnt[1] - H)] <- -9999
  y[x > (qnt[2] + H)] <- -9999
  y
}

if(is.null(cat)){
for(zz in 1:len){
datos[,var[zz]]<-remove_outliers(datos[,var[zz]])
}#End for zz
}#End null cat
else{
cate<-as.character(unique(data[,cat]))
lencat<-length(cate)
for(zz in 1:len){
for(hh in 1:lencat){
filas<-which(data[,cat]==cate[hh])
datos[filas,var[zz]]<-remove_outliers(datos[filas,var[zz]])
}#End for hh
}#End for zz
}


if(!is.null(varCode)){
datos2<-subset(data, select=varCode)
datos3<-data.frame(datos2,datos)
}
else{
datos3<-datos
}

dim<-dim(datos3)
filass<-1
if(remove==TRUE){
for(hh in 1:dim[1]){
pp<-any(datos3[hh,]==-9999, na.rm=TRUE)
if(pp==TRUE){
filass<-append(filass,hh)
}
}
}

if(length(filass)>1){
datos3<-datos3[-filass[-1],]
}

if(Nan==TRUE){
datos3<-replace(datos3, datos3 == -9999, NA)
}


if(dec=="."){
write.csv(x=datos3,file= file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = datos3,file = file, fileEncoding = "", row.names=row.names,na=na)
}


}