\name{ZXV1}
\docType{data}
\alias{ZXV1}
\encoding{latin1}
\title{ANCHOVY CONDITION FACTOR}
\usage{data(ZXV1)}
\description{Monthly average values of the anchovy condition factor (\emph{Engraulis encrasicolus}), temperature (in degree C), chlorophyll (in \eqn{mg m^{-3}}) and stability of the water column (in \eqn{m^{3} s^{-3}}) over several years in the Strait of Sicily (Basilone et al., 2006).} 
\format{A data frame with 6 columns: year, month, condition factor, chlorophyll, temperature and stability of the water column.}
\references{
Basilone, G., Guisande, C., Patti, B., Mazzola, S., Cuttitta, A., Bonanno, A., Vergara, A.R. & Maneiro, I. (2006) Effect of habitat conditions on reproduction of the European anchovy (\emph{Engraulis encrasicolus}) in the Strait of Sicily. \emph{Fisheries Oceanography}, 15: 271-280.
}
\keyword{ZXV1}

